$LARGE
*COPY ATOM
      subroutine ATOM(nig,*)
c     called by STIDY
 
      PARAMETER(lc1=97,lc2=122,lu1=65,lu2=90,iof=32)
*IBM  PARAMETER(lc1=129,lc2=169,lu1=193,lu2=233,iof=-64)
c     lc1,lc2,lu1,lu2 are values of ASCII characters a & z (in resp.
c     lower- and upper case);
      common long,nout,idm,inf,isc,ipol,r,ngr,iocfl,vol,nfl,volrat
      common /at/iat,pos(3),ihex,fnum
      common /atch/elt1,elt2,f
      common /bl1/ sml, aa, bb ,csh
      common /matr/ifmat,ifsh,ifplus,xmat(3,3),plus(3),sh(3),nabc,nsh,
     1 nshtra,ifnig,xmsave(3,3),shif(3),minsh
 
      character*1 t(70),sml(27),dat(30),aux*10,f*5,lab*4
      character aa(107)*11,bb(39)*15,csh(17)*14,elt1*2,elt2*4
      dimension numb(2),x(3)
 
      elt1 = '  '
      elt2 = '    '
      f = '     '
      isl = 0
      fnum = 1.
      do 46 i=1,30
   46 dat(i) = ' '
  111 if(idm.eq.1) then
        if(iat.eq.0)write(6,2)
    2 format(' Atom identification, coordinates and occupation',
     1' factor (if < 1)?'/
     2' The word END ends the atom list.')
      if(iat.gt.0)write(*,3)
    3 format(' Next atom?')
      endif
c    Look where coordinates are written in array t
   10   read(inf,4) t
        if(t(1).eq.'?') then
           write(*,799)
  799 format(/' Atom identification (1 or 2 letters and as option',
     1' a number),'/' the 3 coordinates (fractions are allowed) and',
     2' the occupation factor'/' (if < 1).')
           write(*,800)
  800 format(' One record for each atom site in the assymmetric',
     1' unit.'/' For recognition of special positions, non-rational',
     2' numbers should'/' be given with at least 5 decimals, or as',
     3' fractions. The order'/' in which the sites of different',
     4' elements are entered determines'/' the indenting in the',
     5' final atom site list. Coordinates for mixed'/' sites should',
     6' be entered only once, with a dummy element name.'/
     7' The program will then ask you to define the actual',
     8' occupation.'/)
          go to 111
        endif
        if(inf.eq.5) write(11,4) t
    4   format(70a1)
      iat = iat+1
 
*     take care of AUTHOR, JRNL, DEFINE records on input-file...
      do 444 i=1,4
  444 lab(i:i)= t(i)
      if(lab.eq.'AUTH'.or.lab.eq.'JRNL'.or.lab.eq.'DEFI') then
        write(13,4) t
        go to 10
      endif
 
      do 5 i=1,70
      if(t(i).eq.'.'.or.t(i).eq.'/'.or.t(i).eq.'0'.and.t(i-1).eq.' ')
     1 then
        if(i.lt.3) then
          write(*,13) t
          write(nout,13) t
          go to 10
        endif
      if(t(i).eq.'.') then
      ij = i-1
        if(t(i-1).eq.'0') ij = i-2
          if(t(i-2).eq.'+'.or.t(i-2).eq.'-') ij = i-3
         if(t(i-1).eq.'-'.or.t(i-1).eq.'+') ij = i-2
      else if(t(i).eq.'/') then
      i1 = i-1
      do 8 j=1,i1
      k = i-j
      if(t(k).eq.' ') go to 9
    8 continue
      write(*,11)
   11 format(' Items should by separated by at least one blank.',
     1 ' Write this line again')
      go to 10
    9 ij = k
      else
      ij = i-1
      endif
        else
      go to 5
        endif
       go to 6
   5  continue
      ij = 70
   6  continue
c     Atom identification (element name)
      ie = 1
        do 7 i=1,ij
       if(t(i).eq.' ') go to 7
      kk = ichar(t(i))
      if(kk.ge.lu1.and.kk.le.lu2) go to 15
      if(kk.ge.lc1.and.kk.le.lc2) then
        kk = kk -iof
        t(i) = char(kk)
        go to 15
      endif
      go to 7
 
   15 elt1(1:1) = t(i)
      kk = ichar(t(i+1))
      if(kk.ge.lc1.and.kk.le.lc2) go to 43
      if(kk.ge.lu1.and.kk.le.lu2) then
        kk = kk +iof
        t(i+1) = char(kk)
        go to 43
      endif
 
      elt1(2:2) = ' '
      i1 = i+1
      go to 12
 
   43 elt1(2:2) = t(i+1)
      i1 = i+2
      if(elt1.ne.'En') go to 12
      return 1
    7 continue
 
      write(6,13) t
      write(nout,13) t
   13 format(' Error, no element name; Write this line again'/' ',70a1)
      go to 10
 
c     Atom identification (number or other, but no . and no /)
   12 if(ij.eq.70) then
c     no . or / in inputrecord, which means that all coordinates =0.
c     Look for atomidentifier:
        do 16 i=i1,70
        if(t(i).eq.'0'.and.t(i-1).eq.' ') go to 17
   16   continue
        go to 48
   17   ij = i-2
      endif
 
   48 do 18 i=i1,ij
      if(t(i).ne.' ') go to 19
   18 continue
      if(ij.eq.70) go to 47
      go to 20
   19 elt2(1:1) = t(i)
      do 21 j=1,3
      k = i+j
      if(t(k).eq.' ') go to 20
      ie = j+1
   21 elt2(ie:ie) = t(k)
 
*     right-adjust elt-number:
   20 do 72 j=4,1,-1
      if(elt2(j:j).eq.' ') go to 72
      if(j.eq.4) go to 75
      do 71 k=1,j
      l=j+1 - k
      kk = 5 - k
   71 elt2(kk:kk) = elt2(l:l)
      elt2(1:kk-1) = ' '
      go to 75
   72 continue
   75 continue
 
c     Atomic positions
   47 if(ij.eq.70) then
        do 42 i=1,3
   42   pos(i) = 0.
        fnum = 1.
        if(long.eq.2) write(nout,'( )')
        if(long.eq.0) go to 45
        write(nout,49) elt1,elt2
        if(isc.eq.1)write(*,49) elt1,elt2
   49 format(' ',a2,1x,a4,2x,'0         0         0')
        go to 45
      endif
      j=0
      ij = ij + 1
      do 22 k=1,3
      do 23 i=ij,70
      if(t(i).ne.' ') go to 26
   23 continue
      k1 = (k-1)*10+2
  24  dat(k1) = '0'
      if(k1.gt.20) go to 25
      k1 = k1 + 10
      go to 24
   26 j=j+1
      dat(j) = t(i)
      i2 = i + 1
      do 27 ii=i2,70
      if(t(ii).eq.' ') go to 28
      j = j + 1
      dat(j) = t(ii)
   27 continue
      go to 37
 
   28 j1= j+1
      j2 = (j1/10+1)*10
      if(j1.ge.j2) go to 29
      do 30 l=j1,j2
   30 dat(l) = ' '
   29 ij = ii+1
      j = j2
   22 continue
 
c     look for occupation factor.
   25 do 76 ii=ij,70
      if(t(ii).ne.' ') go to 79
   76 continue
      go to 73
   79 i1 = ii+4
      j = 0
      do 74 i=ii,i1
      if(t(i).eq.'/') isl = i
      j = j + 1
   74 f(j:j) = t(i)
   73 if(long.eq.2) write(nout,'( )')
      if(long.gt.0) then
        if(isc.eq.1)write(*,31) elt1,elt2,dat,f
        write(nout,31) elt1,elt2,dat,f
      endif
   31 format(' ',a2,1x,a4,2x,30a1,5x,a5)
 
c----numerical value of occupation factor -> fnum
   37 if(isl.eq.0) then
        read(f,'(f5.1)') fnum
      else
        num1 = 0
        num2 = 0
        do 91 i=ii,isl-1
        read(t(i),'(i1)',err = 95) n
        num1 = 10*num1 + n
   91   continue
        do 92 i=isl+1,i1
        if(t(i).eq.' ') go to 93
        read(t(i),'(i1)',err = 95) n
        num2 = 10*num2 + n
   92   continue
   93   fnum = float(num1)/float(num2)
      endif
      if(fnum.eq.0.) fnum = 1.
      go to 50
   95 if(isc.eq.1)write(*,94) f
      write(nout,94) f
   94 format(' WARNING : Error in reading occupation factor',a5,
     1 ' we take value f=1')
      fnum = 1.
c
C-----ATOM RECORDS:
   50 do 51 i=1,3
      j1 = (i-1)*10 + 1
      j2 = j1 + 9
      aux = ' '
      jj = 0
      do 52 k=j1,j2
      if (dat(k).eq.'/') go to 55
      jj = jj + 1
      aux(jj:jj) = dat(k)
   52 continue
      read(aux,54) pos(i)
   54 format (f10.5)
      go to 51
C
C----- SLASH FOUND
   55 kkk = 1
      numb(1) = 0
      numb(2) = 0
      neg = 1
      do 57 k = j1,j2
      if (dat(k).eq.' ') go to 57
      if (dat(k).eq.'/') go to 60
      if(dat(k).ne.'-') go to 58
      neg = -1
      go to 57
   58 kk= ichar(dat(k))-ichar('0')
      if(kk.ge.0.and.kk.le.9) go to 61
      write (nout,62) dat(k),dat
      write (*,62) dat(k),dat
   62 format (' Unrecognized number in subroutine ATOM : ',a1,2x,30a1)
      return
   61 numb(kkk) = kk + 10.*numb(kkk)
      go to 57
   60 kkk = 2
   57 continue
 
      f1 = numb(1)*neg
      f2 = numb(2)
      pos(i) = f1/f2
   51 continue
 
   45 continue
 
c     eventually add shift to obtain origin at centre of symmetry
      if(ifsh.eq.1) then
        do 85 j=1,3
   85   pos(j) = pos(j) - sh(j)
      endif
 
c     Apply MATRIX to input positions
      if(ifmat.eq.2) then
        do 80 j=1,3
       x(j) = pos(1)*xmat(1,j)+pos(2)*xmat(2,j)+pos(3)*xmat(3,j)-plus(j)
   80  continue
       do 81 j=1,3
   81  pos(j) = x(j)
      endif
 
c     If enantiomorphic space group, change sign of all coordinates
      if(ifmat.eq.1) then
         do 68 j=1,3
   68    pos(j) = 1.-pos(j)
      endif
c-----put positions between 0 and 1 :
      do 63 j=1,3
   66 if(pos(j).ge.-.000001) go to 65
      pos(j) = pos(j) + 1.
      go to 66
   65 if(pos(j).lt..999999) go to 63
      pos(j) = pos(j) - 1.
      go to 65
   63 continue
 
c-----Coordinates < 0.001 are considered = 0 when transformed from
c     rhombohedral setting :
      if(ihex.eq.1) then
        do 87 j=1,3
   87   if(abs(pos(j)).lt..001) pos(j) = 0.
        endif
 
      if(long.eq.0) return
      if(nig.eq.0) then
        if(ifmat.gt.0.or.ifsh.eq.1.or.ihex.eq.1) then
          if(isc.eq.1) write(*,64)elt1,elt2,pos,f
          write(nout,64)elt1,elt2,pos,f
   64 format(' Input changed into : ',a2,a4,3f9.5,5x,a5/)
          endif
        endif
        return
      end
*COPY NIGOPT
      subroutine NIGOPT(pear,ipears,pmin,kelt,ncs,ntio,*)
c      called by MAIN of STIDY
c     changes space group to P1 or P-1; reads atomcoordinates and puts
c      them into the appropriate array
c
      PARAMETER(numat=150,nelts=8)
      common long,nout,idm,inf,isc,ipol,r,ngr,iocfl,vol,nfl,volrat
      common /at/iat,pos(3),ihex,fnum
      common /atch/elt1,elt2,f
      common /brz/ngo,ir(48,3,3),it(48,3),nbr
      common /bur/nt,spgr
      common /cel/ a,b,c,al,be,ga,alf,bet,gam,cosa,cosb,cosg
      common /ch/xa(3,numat)
      common /matr/ifmat,ifsh,ifplus,xmat(3,3),plus(3),sh(3),nabc,nsh,
     1 nshtra,ifnig,xmsave(3,3),shif(3),minsh
      common /orgin/nor,orgadd(3,8),ntext,icoord
      common /posi/x(3,192),dist(192),kount
      common /res/ atom1,atom2,foccu,intxt,code,elt
      common /rot/xrot(3,numat),natom
      common /sp/n,nw,ns(26),is(27),mult(15),nset(8),kset,mu,kord
      common /trans/s(3,3),u(9),t(9),p(9)
      common/trip/ dmin,min,korder(192),iflag,xmin(3,numat),
     1dis(numat),mul(numat),let(numat),nrset(numat),nnset(8,numat)
 
      character*1 nt(16),code(2),ansr,intxt*40
      character spgr*10,atom1(numat)*2,atom2(numat)*4,foccu(numat)*5
      character elt(nelts)*2,elt1*2,elt2*4,f*5,dat*50
      dimension pear(nelts),xx(3,numat),sav(3,3),nent(11),orga(3),y(3),
     1 ff(numat)
      data nent/76,91,92,144,151,152,169,171,178,180,213/
 
      ep = 0.000001
      nig = 1
      do 15 i=1,3
      do 15 j=1,3
      sav(j,i) = xmat(j,i)
  15  xmat(j,i) = xmsave(j,i)
      ipears = 0
      pmin = 0.
c
c-----if centric group, take only half of positions :
      if(ncs.eq.0) ngo = ngo/2
      natom = 0
      kelt = 0
      knt = 0
c     set centring as for primitive cell :
      nbr = 1
   20 call ATOM(nig,*30)
      call POSIT
c
c     transform atompositions according to cellreduction and get out
c     doubles
      do 23 i = 1,kount
      if(ifnig.eq.2) then
        do 45 j=1,3
        pos(j)= x(1,i)*sav(1,j)+x(2,i)*sav(2,j)+x(3,i)*sav(3,j)
   45   continue
c-----put positions between 0 and 1 :
        do 46 j=1,3
   47   if(pos(j).ge.-.000001) go to 48
        pos(j) = pos(j) + 1.
        go to 47
   48   if(pos(j).lt..999999) go to 46
        pos(j) = pos(j) - 1.
        go to 48
   46   continue
      else
        do 57 j=1,3
   57   pos(j) = x(j,i)
      endif
c     get out doubles caused by transformation :
      if(knt.gt.0) then
        do 28 j=1,knt
        if(abs(pos(1)-xx(1,j)).lt.ep.and.abs(pos(2)-xx(2,j)).lt.ep.and.
     1  abs(pos(3)-xx(3,j)).lt.ep) go to 23
   28   continue
c     for P-1 eliminate also positions -x,-y,-z :
        if(ncs.eq.0) then
          do 29 j=1,knt
          do 44 k=1,3
          y(k) = pos(k) + xx(k,j)
   44     if(y(k).gt.0.999999) y(k) = y(k) - 1.
          if(abs(y(1)).lt.ep.and.abs(y(2)).lt.ep.and.abs(y(3)).lt.ep)
     1    go to 23
   29     continue
        endif
      endif
      knt = knt + 1
      atom1(knt) = elt1
      atom2(knt) = elt2
      foccu(knt) = f
      ff(knt) = fnum
      do 24 j=1,3
   24 xx(j,knt) = pos(j)
   23 continue
      if(knt.ge.numat) go to 50
c     next atom :
      go to  20
 
   30 natom = knt
      if(long.eq.2) then
        if(isc.eq.1) write(*,27)
        write(nout,27)
   27   format(//' Atoms in asymmetric unit of new space group :')
        do  25 i=1,natom
        if(isc.eq.1) write(*, 26)atom1(i),atom2(i),(xx(j,i),j=1,3)
   25   write(nout,26)atom1(i),atom2(i),(xx(j,i),j=1,3)
   26   format(' ',a2,a4,5x,3f9.5)
      endif
 
c     new symmetry factors :
      do 40 i=1,3
      do 40 j=1,3
      do 40 k=1,48
   40 ir(k,j,i) = 0
      do 41 i=1,3
      do 41 j=1,48
   41 it(j,i) = 0
c
      do 4 i=1,8
      do 4 j=1,3
    4 orgadd(j,i) = 0.
c
      nt(1) = 'P'
      nt(2) = ' '
      code(1) = 'a'
      code(2) = 'P'
      if(ncs.eq.0) then
c       centric group; change to P -1 .
        nt(3) = '-'
        nt(4) = '1'
        spgr ='P -1'
        ngr = 2
        n = 8
        nw = 2
        ntio = 0
        do 6 i=1,8
        is(i) = 1
    6   ns(i) = 9-i
        mult(1) = 1
        mult(2) = 2
        do 5 i=1,3
        ir(1,i,i) = 1
    5   ir(2,i,i) = -1
        ngo = 2
        nor = 8
        ipol = 1
        orgadd(1,2) = .5
        orgadd(2,3) = .5
        orgadd(3,4) = .5
        orgadd(2,5) = .5
        orgadd(3,5) = .5
        orgadd(1,6) = .5
        orgadd(3,6) = .5
        orgadd(1,7) = .5
        orgadd(2,7) = .5
        orgadd(1,8) = .5
        orgadd(2,8) = .5
        orgadd(3,8) = .5
      else
        spgr ='P 1'
        ipol = 0
        nor = -31
   58   if(idm.eq.1) then
          write(*,49)
   49 format(' Polar group. To compute the "best" origin type "Y",'/
     1 ' otherwise type "N" and the coordinates of the origin.')
          dat = ' '
          read(inf,52)ansr,dat
   52 format(a1,a50)
          if(ansr.eq.'?') then
            write(*,810)
  810 format(' If you do not wish the program to compute the "best"',
     1' origin'/' for the polar directions, type "N" and the',
     2' coordinates'/' of the origin in free format.'/)
            go to 58
          endif
          if(inf.eq.5) write(11,52) ansr,dat
          if(ansr.eq.'N'.or.ansr.eq.'n') then
            if(dat.eq.' ') then
              orga(1) = 0.
              orga(2) = 0.
              orga(3) = 0.
            else
              rewind 8
              write(8,56) dat
  56          format(a50)
              rewind 8
              read(8,*) orga
            endif
            ipol = 1
            nor = 1
            do 53 j=1,3
   53       orgadd(j,1) = orga(j)
            if(long.gt.0) write(nout,54) orga
   54       format(' Polar group with origin ',3f8.5)
          endif
        endif
        nt(3) = '1'
        nt(4) = ' '
        n = 0
        nw = 1
        is(1) = 1
        ntio = 1
        mult(1) = 1
        ir(1,1,1) = 1
        ir(1,2,2) = 1
        ir(1,3,3) = 1
        ngo = 1
        ngr = 1
c     in the case of one of the enantiomorphic space group pairs,
c     setting -x,-y,-z should NOT be considered :
        do 8 i=1,11
        if(ngr.ne.nent(i)) go to 8
        ntio = 0
        nfl = 1
        go to 7
    8   continue
    7   continue
      endif
      do 10 i=5,16
   10 nt(i) = ' '
 
      if(long.gt.0) then
        if(isc.eq.1)write(*, 85) ngr,spgr
        write(nout, 85) ngr,spgr
      endif
   85 format(/' Niggli reduced cell option; new space group:', i2,5x,a/)
 
c     transform atompositions according to cellreduction; then generate
c     all positions with POSIT
      do 31 ia = 1,natom
      do 32 j=1,3
   32 pos(j) = xx(j,ia)
 
      call POSIT
      kset = 0
      if(n.eq.0) then
      mu = mult(1)
      kord = 1
      else
      call SPEC(nig)
      endif
c-----number of atoms for Pearson code :
      fmu = float(mu)
      fn = ff(ia)* fmu
      ipears = ipears + mu
      pmin = pmin + fmu - fn
      elt1 = atom1(ia)
      if(kelt.gt.0) then
        do 35 i=1,kelt
        if(elt1.eq.elt(i)) go to 36
   35   continue
      endif
      kelt = kelt + 1
      if(kelt.gt.nelts) then
        write(*,60) nelts
        write(nout,60) nelts
        kelt = kelt - 1
      endif
      elt(kelt) = elt1
      i = kelt
   36 pear(i) = pear(i) + fn
      do 42 j=1,3
   42 xa(j,ia) = x(j,1)
      if(kset.eq.0) go to 31
      do 43 j=1,kset
   43 nnset(j,ia) = nset(j)
      nrset(ia) = kset
 
   31 continue
 
      return
 
   50 write(nout,51)
      write(*,51)
   51 format(' too many atoms for Niggli option; stop job')
*    To rerun job, change parameter NUMAT in MAIN and subroutines Choice
*    Nigopt, Order, Polar, Polorg, Print, Renum, Result, Rotat and XYZ.
      return 1
 
   60 format(' More than ',i3,' different elements in structure,'/
     1' giving wrong Pearson code and displacements in output.')
*    Change variable NELTS in PARAMETER statement in MAIN, NIGOPT,
*    ORDER, PRINT, RENUM and RESULT.
 
      end
*COPY POSIT
      subroutine POSIT
c     Called by main program for STIDY
c     Generates all atompositions for given space group
 
      common long,nout,idm,inf,isc,ipol,rr,ngr,iocfl,vol,nfl,volrat
      common /at/iat,pos(3),ihex,fnum
      common /brz/ngo,r,t,nbr
      common /posi/x(3,192),dist(192),kount
      dimension f(3,3)
      integer r(48,3,3),t(48,3)
 
      ng = ngo
      k = ng
      p1 = 1./3.
      p2 = 2./3.
    1 continue
 
c     generation of coordinates
      do 20 i=1,ng
      do 20 j=1,3
      do 2 l=1,3
    2 f(l,j) = r(i,j,l)**2
      s = float(t(i,j))/24.
      x(j,i) = r(i,j,1)*pos(1)+r(i,j,2)*pos(2)+r(i,j,3)*pos(3)+s
   20 continue
 
c     centrings (nbr = 1 -> 6  corresponds to centrings P,A,C,F,I,R) :
      go to (31,32,33,32,35,36) ,nbr
   32 do 42 i=1,ng
      k = ng + i
      x(1,k) = x(1,i)
      x(2,k) = x(2,i) + .5
      x(3,k) = x(3,i) + .5
   42 continue
      ng = k
      if(nbr.ne.4) go to 31
   33 do 43 i=1,ng
      k = ng + i
      x(1,k) = x(1,i) + .5
      x(2,k) = x(2,i) + .5
      x(3,k) = x(3,i)
   43 continue
      ng = k
      go to 31
   35 do 45 i=1,ng
      k = ng + i
      do 45 j=1,3
   45 x(j,k) = x(j,i) + .5
      ng = k
      go to 31
   36 do 46 i=1,ng
      k = ng + i
      x(1,k) = x(1,i) + p2
      x(2,k) = x(2,i) + p1
      x(3,k) = x(3,i) + p1
   46 continue
      k1 = ng + ng
      do 47 i=1,ng
      k = k1 + i
      x(1,k) = x(1,i) + p1
      x(2,k) = x(2,i) + p2
      x(3,k) = x(3,i) + p2
   47 continue
      ng = k
c----- Put positions between 0 and 1:
   31 do 6 j=1,ng
      do 6 i=1,3
      eps = -0.000001
      eps1 = 1.+eps
    7 if (x(i,j).ge.eps) go to 8
      x(i,j) = x(i,j) + 1.
      go to 7
    8 if (x(i,j).lt.eps1) go to 6
      x(i,j) = x(i,j) - 1.
      go to 8
    6 continue
 
c-----Get out doubles
      eps = 0.0001
      ng1 = ng-1
      do 10 i=1,ng1
      xx = x(1,i)
      if (xx.gt.1.) go to 10
      yy = x(2,i)
      zz = x(3,i)
      i1 = i + 1
      do 11 j=i1,ng
      if (x(1,j).gt.1.) go to 11
      d1 = abs(x(1,j) - xx)
      d2 = abs(x(2,j) - yy)
      d3 = abs(x(3,j) - zz)
      if (d1.lt.eps.and.d2.lt.eps.and.d3.lt.eps) x(1,j) = 10.
   11 continue
   10 continue
      kount = 0
      dmin = 100.
      do 12 i=1,ng
      if (x(1,i).gt.1.) go to 12
      kount = kount + 1
      sum = 0.
      do 14 j=1,3
   14 sum = sum + x(j,i)**2
      dist(kount) = sqrt(sum)
      do 13 j=1,3
      x(j,kount) = x(j,i)
   13 continue
   12 continue
 
      return
      end
*COPY PRINT
      subroutine PRINT(nn,ior,natom,sum,finxyz,mul,let)
c     prints chosen triplets if long output is desired (long = 2)
c     called from MAIN(nn=1) and from POLAR(nn=2)
 
      PARAMETER(numat=150,ntot= 1000,kor=20,nelts=8)
      common long,nout,idm,inf,isc,ipol,r,ngr,iocfl,vol,nfl,volrat
      common/bl1/ sml, aa, bb ,csh
      common /bl3/ text(21)
      common /orgin/nor,orgadd(3,8),ntext,icoord
      common/pol/npol,xpol(3,ntot),xp(3,ntot),orga(3),smin,
     1 kkord(numat),nat(ntot)
      common /res/ atom1,atom2,foccu,intxt,code,elt
      dimension finxyz(3,numat),mul(numat),let(numat)
      character atom1(numat)*2,atom2(numat)*4,foccu(numat)*5,intxt*40
      character aa(107)*11,bb(39)*15,text*17,sml(27)*1,csh(17)*14
      character code(2)*1,elt(nelts)*2
 
      if(nn.eq.1) then
        write(nout,43) text(ntext),(orgadd(j,ior),j=1,3)
        if(isc.eq.1)write(*,43) text(ntext),(orgadd(j,ior),j=1,3)
      else if(nn.eq.2) then
        write(nout,43) text(ntext),orga
        if(isc.eq.1)write(*,43) text(ntext),orga
      endif
   43 format(//' Chosen positions for setting ',a17/' origin shift ',
     1 3f8.5)
      write(nout,20)
      if(isc.eq.1)write(*,20)
   20 format(' atom ',9x,'x',9x,'y',9x,'z',7x,'occup')
      do 35 i=1,natom
      k = let(i)
      write(nout,42)atom1(i),atom2(i),(finxyz(j,i),j=1,3),foccu(i),
     1mul(i),sml(k)
      if(isc.eq.1)write(*,42)atom1(i),atom2(i),(finxyz(j,i),j=1,3),
     1foccu(i),mul(i),sml(k)
   35 continue
      write(nout,63) sum
      if(isc.eq.1)write(*,63) sum
   42 format(' ',a2,1x,a4,3f10.5,5x,a5,5x,i3,a1)
   63 format(' Standardization parameter gamma = ',f8.4)
 
      return
      end
*COPY SPEC
      subroutine SPEC(nig)
c     detects special positions for atom coordinates
      common long,nout,idm,inf,isc,ipol,r,ngr,iocfl,vol,nfl,volrat
      common/bl1/ sml, aa, bb ,csh
      common /bl2/ specia(3,107)
      common /posi/x(3,192),dist(192),kount
      common /sp/nspec,nw,ns(26),is(27),mult(15),nset(8),kset,km,ipos
      character sml(27)*1,aa(107)*11,bb(39)*15,csh(17)*14
      dimension pos(3)
 
C-----Does one of the positions correspond to special Wyckoff position ?
      iatom = 1
      do 1 npos=1,kount
      np = npos
      do 2 j=1,3
    2 pos(j) = x(j,np)
      do 3 i=1,nspec
      k = ns(i)
      if(k.lt.0) go to 10
      do 4 j=1,3
      if(specia(j,k).lt.0.) go to 4
      if(abs(pos(j)-specia(j,k)).gt..0001) go to 3
    4 continue
      if(kset.eq.0) go to 5
      if(is(i).ge.kset) go to 3
    5 kset = is(i)
      iatom = np
      ipos = i
      go to 3
C-----Look at 'special' special positions in subroutine SPPOS
   10 ifound = 0
      call SPPOS (pos,ifound,k)
      if(ifound.eq.0) go to 3
 
      if(kset.eq.0) go to 11
      if(is(i).ge.kset) go to 3
   11 kset = is(i)
      iatom = np
      ipos = i
 
    3 continue
    1 continue
      if(kset.eq.0) then
        km = mult(nw)
        ipos = nspec + 1
        if(long.eq.2.and.nig.eq.0) then
          if(isc.eq.1)write(*,6) km,sml(ipos)
          write(nout,6) km,sml(ipos)
    6 format(' General position ',i3,a1)
        endif
        return
      endif
 
      km = mult(kset)
      if(iatom.gt.1) then
      do 20 j=1,3
  20  x(j,1) = x(j,iatom)
      endif
      k = ns(ipos)
 
   30 if(long.eq.2.and.nig.eq.0) then
       if(k.gt.0) then
         if(isc.eq.1)write(*,25) aa(k),km,sml(ipos)
         write(nout,25) aa(k),km,sml(ipos)
   25 format(' Special position : ',A15,' multiplicity ',i3,
     1'  Wyckoff letter:',A2)
       else
         k = -k
         write(nout,25) bb(k),km,sml(ipos)
         if(isc.eq.1)write(*,25) bb(k),km,sml(ipos)
        endif
      endif
      ii = 0
      nn = is(ipos)
      do 22 i=1,nspec
      if(nn.ne.is(i)) go to 22
      ii = ii + 1
      nset(ii) = ns(i)
   22 continue
      kset = ii
      if(ii.gt.0.and.long.eq.2) then
        if(isc.eq.1)write(*,23)
        write(nout,23)
   23   format(' All possible special positions for this atom :')
        do 24 j=1,ii
        k = nset(j)
        if(k.gt.0) then
          write(nout,26) aa(k)
          if(isc.eq.1) write(*,26) aa(k)
   26 format(' ',a15)
        else
          k = -k
          write(nout,26) bb(k)
          if(isc.eq.1)write(*,26) bb(k)
        endif
   24   continue
      endif
      return
      end
*COPY SPPOS
      subroutine SPPOS(pos,ifound,k)
      dimension pos(3)
      DATA EPS/.0001/,EPS1/.9999/
      K = -K
      GO TO (421,421,421,421,421,421,422,422,422,422,422,422,422,
     1 425,425,425,426,427,427,428,428,428,428,423,423,423,424,424,
     2 429,429,432,432,435,435,421,421,422,425,428),K
  421 IF(ABS(POS(1)-POS(2)).GT.0.0005) GO TO 411
      IF(K.EQ.36) GO TO 450
      IF(K.EQ.35) THEN
        IF(ABS(POS(2)-POS(3)).LT.0.0005) GO TO 450
        GO TO 411
      ENDIF
      GO TO (501,502,503,504,505,506),K
  501 IF(ABS(POS(3)).LT.0.0005) GO TO 450
      IF(ABS(POS(3)-1.).LT.0.0005) GO TO 450
      GO TO 411
  502 IF(ABS(POS(3)-.5).LT.0.0005) GO TO 450
      GO TO 411
  503 IF(ABS(POS(3)-.25).LT.0.0005) GO TO 450
      GO TO 411
  504 IF(ABS(POS(3)-.75).LT.0.0005) GO TO 450
      GO TO 411
  505 IF(ABS(POS(3)-.375).LT.0.0005) GO TO 450
      GO TO 411
  506 IF(ABS(POS(3)-.625).LT.0.0005) GO TO 450
      GO TO 411
C
  422 A = 1.-POS(2)
      IF(A.LT.EPS) A = A + 1.
      IF(ABS(A-POS(1)).GT.0.0005) GO TO 411
      IF(K.EQ.37) GO TO 450
      K1 = K - 6
      GO TO (501,502,503,512,513,514,515), K1
  512 IF(ABS(POS(3)-.3333).LT.0.0005) GO TO 450
      GO TO 411
  513 IF(ABS(POS(3)-.6667).LT.0.0005) GO TO 450
      GO TO 411
  514 IF(ABS(POS(3)-.1667).LT.0.0005) GO TO 450
      GO TO 411
  515 IF(ABS(POS(3)-.8333).LT.0.0005) GO TO 450
      GO TO 411
C
  423 IF(ABS(POS(2)-POS(3)).GT..0005) GO TO 411
      K1 = K - 23
      GO TO (516,517,518),K1
  516 IF(ABS(POS(1)).LT.0.0005) GO TO 450
      GO TO 411
  517 IF(ABS(POS(1)-.5).LT.0.0005) GO TO 450
      GO TO 411
  518 IF(ABS(POS(1)-.25).LT.0.0005) GO TO 450
      GO TO 411
C
  424 A = 1.-POS(2)
      IF(A.LT.EPS) A = A + 1.
      IF(ABS(A-POS(3)).GT.0.0005) GO TO 411
      IF(K.EQ.27.AND.ABS(POS(1)).LT.0.0005) GO TO 450
      IF(K.EQ.28.AND.ABS(POS(1)-.25).LT.0.0005) GO TO 450
      GO TO 411
  425 A = POS(1) + .5
      IF(A.GT.EPS1) A = A -1.
      IF(ABS(A-POS(2)).GT.0.0005) GO TO 411
      IF(K.EQ.38) GO TO 450
      K1 = K - 13
      GO TO (503,502,501),K1
  426 A = .5 - POS(1)
      IF(A.LT.EPS) A = A + 1.
      IF(ABS(A-POS(2)).LT.0.0005.AND.ABS(POS(3)-.25).LT.0.0005)GO TO 450
      GO TO 411
  427 A = POS(1) + 0.25
      IF(A.GT.EPS1) A = A -1.
      IF(ABS(A-POS(2)).GT.0.0005) GO TO 411
      IF(K.EQ.18.AND.ABS(POS(3)-.125).LT.0.0005) GO TO 450
      IF(K.EQ.19.AND.ABS(POS(3)-.875).LT.0.0005) GO TO 450
      GO TO 411
  428 A = POS(1) + POS(1)
      IF(A.GT.EPS1) A = A - 1.
      IF(ABS(A-POS(2)).GT.0.0005) GO TO 411
      IF(K.EQ.39) GO TO 450
      K1 = K - 19
      GO TO(501,502,503,504),K1
  429 IF(ABS(POS(1)-.25).GT.0.0005) GO TO 411
      IF(K.EQ.30) GO TO 430
      A = .5 + POS(2)
      IF(A.GT.EPS1) A = A - 1.
      GO TO 431
  430 A = .5 - POS(2)
      IF(A.LT.EPS) A = A + 1.
  431 IF(ABS(A-POS(3)).LT.0.0005) GO TO 450
      GO TO 411
  432 IF(ABS(POS(1) -.5).GT.0.0005) GO TO 411
      IF(K.EQ.32) GO TO 433
      A = .5 + POS(2)
      IF(A.GT.EPS1) A = A - 1.
      GO TO 434
  433 A = 1.-POS(2)
      IF(A.lt.EPS) A = A + 1.
  434 IF(ABS(POS(3) - A).LT.0.0005) GO TO 450
      GO TO 411
  435 IF(ABS(POS(1)-.125).GT.0.0005) GO TO 411
      IF(K.EQ.34) GO TO 436
      A = .25 + POS(2)
      IF(A.GT.EPS1) A = A - 1.
      GO TO 437
  436 A = .25 - POS(2)
      IF(A.LT.EPS) A = A + 1.
  437 IF(ABS(POS(3) - A).GT.0.0005) GO TO 411
C
  450 IFOUND = 1
  411 RETURN
      END
*COPY XYZ
      subroutine XYZ(ia,np,*)
C-----Find coordinate triplet with minimum 'distance':
c     called by MAIN and POLORG (3 times)
      PARAMETER(numat=150,nelts=8)
      common long,nout,idm,inf,isc,ipol,r,ngr,iocfl,vol,nfl,volrat
      common/bl1/ sml, aa, bb ,csh
      common /bl2/ specia(3,107)
      common /posi/x(3,192),dist(192),kount
      common /res/ atom1,atom2,foccu,intxt,code,elt
      common /sp/nspec,nw,ns(26),is(27),mult(15),nset(8),kset,mu,kord
      common/trip/ dmin,min,korder(192),iflag,xmi(3,numat),
     1dis(numat),mul(numat),le(numat),nrset(numat),nnset(8,numat)
      common /xpolar/ ipolar,kpol(3),lowlet
 
      dimension mulset(8),pos(3)
      character sml(27)*1,aa(107)*11,bb(39)*15,csh(17)*14,code*2,
     1 elt(nelts)*2,atom1(numat)*2,atom2(numat)*4,foccu(numat)*5,
     2 intxt*40
 
      kord = 0
      np = 0
      e1 = 0.0001
      e2 = 0.0001
      e3 = 0.0001
      iflag = 0
      meq = 0
      do 35 i=1,kount
   35 korder(i) = nspec + 1
 
      kset = nrset(ia)
      if(kset.gt.0) then
c     exclude atom if not in permitted special position:
        do 1 i=1,kount
        do 2 m = 1,kset
        k = nnset(m,ia)
        if(k.gt.0) then
          do 3 j =1,3
          if(specia(j,k).lt.0) go to 3
          if(abs(x(j,i)-specia(j,k)).gt.0.001) go to 2
    3     continue
          do 4 j=1,nspec
          if(ns(j).ne.k) go to 4
          korder(i) = j
          go to 1
    4     continue
          go to 9
 
        else
          do 7 j=1,3
    7     pos(j) = x(j,i)
          ifound = 0
          call SPPOS(pos,ifound,k)
          if (ifound.eq.0) go to 2
          do 8 j=1,nspec
          kk = -k
          if (kk.eq.ns(j)) go to 10
    8     continue
          go to 9
   10     korder(i) = j
          go to 1
        endif
    2   continue
 
        dist(i) = 100.
        if (long.eq.2) write(nout,11) i, (x(j,i),j=1,3)
    1   continue
      endif
   11 format(' Exclude : ',I2,3F10.5)
 
      if(ipolar.eq.1) then
        klow = 27
        do 93 j=1,kount
        if(korder(j).lt.klow) klow = korder(j)
   93   continue
        if(klow.ne.lowlet) then
          if(long.eq.2)write(nout,92) x(1,1),x(2,1),x(3,3)
   92 format(' exclude atom ',3f8.5,' : not lowest Wyckoff letter')
          dmin = 100.
          return
        endif
      endif
c     Compute 'distance' of permitted position:
      if(long.eq.2) then
        if(isc.eq.1)write(*,40)
        write(nout,40)
   40 format(/' Permitted positions :')
        write(nout,38)
        if(isc.eq.1)write(*,38)
      endif
   38 format(' ',22x,'x',8x,'y',8x,'z',12x,'D')
      do 5 i=1,kount
      if(dist(i).gt.99.) go to 5
*     exclude atom if it is the 'polar one' and coordinate(s) not = 0
      if(ipolar.eq.1) then
        do 70 j=1,3
        k = kpol(j)
        if(k.eq.0) go to 70
        if(x(k,i).ne.0.) go to 71
   70   continue
        go to 72
   71   dist(i) = 100.
        if(long.eq.2) write(nout,73) i,(x(j,i),j=1,3)
   73 format(' We exclude atom ',i3,3f8.5,': polar coordinate(s) not=0')
        go to 5
      endif
   72 continue
      sum = x(1,i)**2 + x(2,i)**2 + x(3,i)**2
      dist(i) = sqrt(sum)
      kk = korder(i)
      k1 = is(kk)
      if(long.eq.2) then
        if(isc.eq.1)write(*,12)i,(x(j,i),j=1,3),dist(i),mult(k1),sml(kk)
        write(nout,12)i,(x(j,i),j=1,3),dist(i),mult(k1),sml(kk)
          go to 5
        else
      endif
   12 format(' ',6x,i3,7x,3f9.5,5x,f8.4,10x,i3,a1)
 
    5 continue
c     find smallest 'distance'
      dmin = 100.
      do 20 i=1,kount
      if (dist(i).ge.dmin) go to 20
      dmin = dist(i)
      min = i
   20 continue
      if(dmin.lt.99.99) go to 21
      if(long.eq.2.and.isc.eq.1)write(*,22)
      if(long.eq.2) write(nout,22)
   22 format(' No permitted choice of coordinate triplet')
      iflag = 1
      return 1
C----Look for other coordinate triplets with same 'distance':
   21 kk = 1
      mulset(1) = min
      e1 = 0.0001
      e2 = 0.0001
      e3 = 0.0001
      do 23 i=1,kount
      if(i.eq.min) go to 23
      if(abs(dist(i)-dmin).gt.e1) go to 23
      kk = kk + 1
      if(kk.gt.8) go to 14
      mulset(kk) = i
   23 continue
      if(kk.eq.1) go to 50
 
      mx = mulset(1)
      xmin= x(1,min)
      do 24 k=2,kk
      i = mulset(k)
      if(abs(x(1,i)-xmin).lt.e1) go to 25
      if(x(1,i)-xmin) 26,25,24
   26 xmin = x(1,i)
      meq = 0
      mx = i
      go to 24
   25 meq = 1
      mx = i
   24 continue
      min = mx
      if(meq.eq.0) go to 15
      ymin = x(2,mx)
      meq = 0
      my = mx
      do 27 k=1,kk
      i = mulset(k)
      if(i.eq.mx) go to 27
      if(abs(x(1,i)-x(1,mx)).gt.e1) go to 27
      if(abs(x(2,i)-ymin).lt.e2) go to 29
      if(x(2,i)-ymin) 28,29,27
   28 ymin = x(2,i)
      meq = 0
      my = i
      go to 27
   29 if(i.eq.my) go to 27
      meq = 1
      my = i
   27 continue
      min = my
      if(meq.eq.0) go to 15
      meq = 0
      mz = my
      zmin = x(3,my)
      do 30 k=1,kk
      i = mulset(k)
      if(i.eq.my) go to 30
      if(abs(x(1,i)-x(1,mx)).gt.e1.or.abs(x(2,i)-x(2,my)).gt.e2)
     1 go to 30
      if(abs(x(3,i)-zmin).lt.e3) go to 31
      if(x(3,i)-zmin) 32,31,30
   32 zmin = x(3,i)
      meq = 0
      mz = i
      go to 30
   31 if(i.eq.mz) go to 30
      meq = 1
      mz = i
   30 continue
      if(meq.eq.1) go to 16
      min = mz
      go to 15
   14 write(nout,17)
      write(*,17)
   17 format(' ERROR : more than 8 possibilities for equal "distance"',
     1 '(subroutine XYZ)')
   15 if(long.eq.2) write(nout,19) dmin
   19 format(/' Several choices give same minimum "distance"',F8.4)
      do 33 k=1,kk
      i = mulset(k)
      if(long.eq.2) write(nout,34) i,(x(j,i),j=1,3)
   33 continue
   34 format(' ',i3,3f9.5)
      go to 50
   16 write(nout,18)
      write(*,18)
   18 format(' subroutine XYZ: all coordinates equal: IMPOSSIBLE]')
   50 kord = korder(min)
      if(kord.le.nspec) np = ns(kord)
      if(np.lt.0) np = 107-np
 
      k1 = is(kord)
      mu = mult(k1)
      if (long.eq.2) then
        write(nout,52) min,(x(j,min),j=1,3),dmin,mu,sml(kord)
        if(isc.eq.1)write(*,52) min,(x(j,min),j=1,3),dmin,mu,sml(kord)
      endif
c     save results for POLORG
      do 53 j=1,3
   53 xmi(j,ia) = x(j,min)
      dis(ia) = dmin
      mul(ia) = mu
      le(ia) = kord
   52 format(/' Chosen : ',I2,3F10.5,5X,'D= ',F6.4,9X,I3,'(',A1,')')
      return
    9 write(nout,6) (x(j,i),j=1,3)
      write(*,6) (x(j,i),j=1,3)
    6 format(' Trouble in finding special position for ',3f9.5)
      iflag = 1
      return 1
      end
*COPY POLAR
      subroutine POLAR(natom,mkord,ii,*)
c-----called by main of S T I D Y
c     This routine prepares data for POLORG where originshifts for
c     polar spacegroups are computed.
      PARAMETER(numat=150,ntot= 1000)
      common long,nout,idm,inf,isc,ipol,r,ngr,iocfl,vol,nfl,volrat
      common /at/iat,pos(3),ihex,fnum
      common /bl3/ text(21)
      common /matr/ifmat,ifsh,ifplus,xmat(3,3),plus(3),sh(3),nabc,nsh,
     1 nshtra,ifnig,xmsave(3,3),shif(3),minsh
      common /orgin/nor,orgadd(3,8),ntext,icoord
      common /par/ gmin
      common /pol/npol,xpol(3,ntot),xp(3,ntot),orga(3),smin,
     1 kkord(numat),nat(ntot)
      common /posi/x(3,192),dist(192),kount
      common /rot/xrot(3,numat),nagain
      common /sp/n,nw,ns(26),is(27),mult(15),nset(8),kset,mu,kord
      common/trip/ dmin,min,korder(192),iflag,xmin(3,numat),
     1dis(numat),mul(numat),le(numat),nrset(numat),nnset(8,numat)
      common /xpolar/ ipolar,kpol(3),lowlet
 
      character text*17
 
      do 30 i=1,ntot
   30 nat(i) = 0
      ismin = is(mkord)
*     find which is 'lowest' Wyckoff letter in set ismin:
      lowlet = 27
      do 90 j=1,27
      if(is(j).ne.ismin) go to 90
      if(j.lt.lowlet) lowlet = j
   90 continue
 
c-----put coordinates of atoms in with highest symmetry in array xp :
      npol = 0
      nig = 0
      do 2 ia = 1,natom
      do 3 j=1,3
      pos(j) = xrot(j,ia)
    3 continue
      call POSIT
      kor = kkord(ia)
      kk= is(kor)
      if(kk.ne.ismin) go to 2
      do 4 j = 1,kount
      npol = npol + 1
      if(npol.gt.ntot) go to 100
      nat(npol) = ia
      do 4 k = 1,3
      xp(k,npol) = x(k,j)
    4 continue
    2 continue
      if(long.eq.2) then
        write(nout,8)
        write(nout,7) (i,(xp(j,i),j=1,3),i=1,npol)
        endif
    8 format(//' Coordinates of atoms for finding origin : ')
    7 format(' ',4(i4,3f9.5,3x))
 
c     ik is number of degenerate directions.
      ik = ii-1
      if(ik.eq.0) ik=1
c     i1 indicates degenerate direction we are treating
      i1 = 3
      if(ii.eq.2) i1 = 2
c     for all nor origins, find origin in degenerate direction(s) :
c-----copy orgadd into orga :
      do 1 ior = 1,nor
      do 12 j=1,3
   12 orga(j) = orgadd(j,ior)
      if(long.eq.2) write(nout,9)text(ntext),orga
    9 format(//' Origin shift for setting ',a17,3F9.5/)
 
      call POLORG(i1,ik,natom,*200)
    1 continue
 
      return
 
  100 write(nout,101)
  101 format(' in POLAR : dimension of xpol is too small')
*     Change value of ntot in PARAMETER of routines POLAR & POLORG.
  200 return 1
       end
*COPY POLORG
      subroutine POLORG(ii,ik,natom,*)
c-----called by  POLAR  (subroutine of  S T I D Y ).
c     This routine computes best values for origin in polar groups
      PARAMETER(numat=150,ntot= 1000,nelts=8)
      common long,nout,idm,inf,isc,ipol,r,ngr,iocfl,vol,nfl,volrat
      common /at/iat,pos(3),ihex,fnum
      common /bl3/ text(21)
      common /matr/ifmat,ifsh,ifplus,xmat(3,3),plus(3),sh(3),nabc,nsh,
     1 nshtra,ifnig,xmsave(3,3),shif(3),minsh
      common /orgin/nor,orgadd(3,8),ntext,icoord
      common /par/ gmin
      common /pol/npol,xpol(3,ntot),xp(3,ntot),orga(3),smin,
     1kkord(numat),nat(ntot)
      common /posi/x(3,192),dist(192),kount
      common /res/ atom1,atom2,foccu,intxt,code,elt
      common /rot/xrot(3,numat),nagain
      common /sp/n,nw,ns(26),is(27),mult(15),nset(8),kset,mu,kord
      common/trip/ dmin,min,korder(192),iflag,xmin(3,numat),
     1dis(numat),mul(numat),le(numat),nrset(numat),nnset(8,numat)
      common /xpolar/ ipolar,kpol(3),lowlet
      dimension xs(3,numat),xm(3,ntot),sadd(3,50),zmin(3),org(3),
     1 nsp(numat),xx(3),nat2(ntot)
      character atom1(numat)*2,atom2(numat)*4,foccu(numat)*5,text*17
      character intxt*40,code*2,elt(nelts)*2
c
      do 1 i=1,3
      zmin(i) = orga(i)
    1 org(i) = orga(i)
      do 11 j=1,ntot
      nat2(j) = 0
      do 11 k=1,3
   11 xm(k,j) = 0.
      rewind 8
      smin = 1000.
c     nr is record number on unit 8 of result.
 
      s = 0.
      ep = -0.000001
      eps = 0.0001
 
c     npol atoms in unit cell, coordinates in xpol, errors in e :
   85 do 80 i=1,npol
      do 80 j=1,3
      xpol(j,i) = xp(j,i)-orga(j)
      if(xpol(j,i).lt.0.) xpol(j,i) = xpol(j,i) + 1.
   80 continue
 
      knt = 0
      nr = 0
      go to (51,52,53) ,ik
   51 if(ii.eq.2) then
        i1 = 2
      else
        i1 = 3
      endif
      i2 = 0
      i3 = 0
      go to 54
   52 i1 = 1
      i2 = 3
      i3 = 0
      go to 54
   53 i1 = 1
      i2 = 2
      i3 = 3
   54 continue
 
      kpol(1) = i1
      kpol(2) = i2
      kpol(3) = i3
 
      kt = 0
      do 2 k = 1,npol
      do 3 kk = 1,3
    3 xx(kk) = 0.
      xx(i1) = xpol(i1,k)
      if(i2.gt.0) xx(i2) = xpol(i2,k)
      if(i3.gt.0) xx(i3) = xpol(i3,k)
 
*     take every shift with same atom only once...
      if(k.eq.1) go to  48
      do 50 kk = 1,kt
      do 47 jj = 1,3
      if(xx(jj).eq.0.) then
        if(jj.ne.i1.and.jj.ne.i2.and.j.ne.i3) go to 47
      endif
      if(abs(xx(jj)-xm(jj,kk)).gt.0.0001) go to 50
   47 continue
      if(nat2(kk).ne.nat(k)) go to 50
      go to 2
   50 continue
   48 kt = kt + 1
      nat2(kt) = nat(k)
      do 49 j=1,3
   49 xm(j,kt) = xx(j)
 
 
c     find standardization parameter corresponding to this origin :
      s = 0.
c     we do not want too much output from subroutine XYZ :
      lsave = long
      long = 0
*     atom iia should have polar coordinate(s) = 0
      iia = nat(k)
 
*     compute nsp for originshift 0
      ipolar = 0
      do 75 ia = 1,natom
      do 72 j=1,3
   72 pos(j) = xrot(j,ia)- orga(j)
      do 73 j=1,3
      if(pos(j).lt.ep) pos(j) = pos(j) + 1.
   73 continue
      call POSIT
      call XYZ(ia,np,*75)
      nsp(ia) = np
   75 continue
      do 15 ia = 1,natom
      do 12 j=1,3
   12 pos(j) = xrot(j,ia)- orga(j)-xx(j)
      do 13 j=1,3
      if(pos(j).lt.ep) pos(j) = pos(j) + 1.
   13 continue
      call POSIT
      ipolar = 0
      if(ia.eq.iia) ipolar = 1
      call XYZ(ia,np,*14)
   14 s = s + dmin
   15 continue
      long = lsave
 
      if(long.eq.2) then
        if(s.gt.99) then
          write(nout,23) orga,xx
          go to 2
        else
          write(nout,21) orga,xx,s
   21   format(' Shift of ',3f8.5,' + ',3f8.5/' gave sum ',f10.4)
   23   format(' Shift of ',3f8.5,' + ',3f8.5,' no triplet possible')
        endif
      endif
      write(8) xx,s
c      look for minimum s-value
      knt = knt + 1
      if(s.lt.smin) then
        smin = s
        nr = knt
        do 17 j=1,3
        zz = xx(j) + orga(j)
        if(zz.gt..99999) zz = zz -1.
   17   zmin(j) = zz
        do 31 ia = 1,natom
        do 31 j=1,3
   31   xs(j,ia) = xmin(j,ia)
      endif
    8 continue
 
    2 continue
*     if no setting possible, return:
      if(smin.gt.99.and.long.eq.2) then
        write(nout,157)  orga,xx
  157   format(' no setting possible for ',6f9.5)
        return
      endif
      do 94 j = 1,3
   94 orga(j) = zmin(j)
      if(ifsh.gt.0.or.ifplus.gt.0) then
        do 112 j=1,3
  112   orga(j) = orga(j) + plus(j)
      endif
 
c     write results on unit 10 :
       write(10,err=45) smin,text(ntext),orga
 
       do 55 ia = 1,natom
      write(10,err=45)nsp(ia),(xs(j,ia),j=1,3),mul(ia),le(ia),foccu(ia)
   55 continue
      if(long.eq.2) call PRINT(2,ior,natom,smin,xs,mul,le)
c     find minimum gamma :
      if(smin.lt.gmin) then
        gmin = smin
      endif
 
c     remember shifts giving slightly greater sum :
      kt1= 0
      if(knt.eq.0) go to 61
      ss = 1.0025*smin
      rewind 8
      kt = 0
      do 60 i=1,knt
      read(8,end=61) xx,s
      kt = kt + 1
      if(kt.eq.nr) go to 60
      if(s.lt.ss) then
        kt1 = kt1 + 1
        do 62 j=1,3
        zz = xx(j) + org(j)
        if(zz.gt..99999) zz = zz -1.
   62   sadd(j,kt1) = zz
      endif
   60 continue
   61 continue
 
      if(long.eq.2.and.isc.eq.1)write(*,35)text(ntext),smin,zmin
      if(long.eq.2)write(nout,35)text(ntext),smin,zmin
   35 format(//' Result of subroutine POLORG for setting ',a17/
     1 ' standardization parameter ',f8.4/' is attained for shift ',
     2 3f8.4)
 
c     write also these higher values on unit 10 :
      if(kt1.gt.0) then
        if(long.eq.2) then
          write(nout,63)
          write(nout,64)((sadd(i,j),i=1,3),j=1,kt1)
  63  format(' Shifts giving slightly higher standardidation :')
  64  format(' ',12f8.5)
        endif
 
      lsave = long
      long = 0
      do 95 i = 1,kt1
      s = 0.
      do 96 ia = 1,natom
      do 97 j=1,3
      pos(j) = xrot(j,ia)-sadd(j,i)
      if(pos(j).lt.ep) pos(j) = pos(j) + 1.
   97 continue
      call POSIT
      ipolar = 0
      call XYZ(ia,np,*99)
   99 s = s + dmin
   96 continue
      do 98 j = 1,3
   98 orga(j) = sadd(j,i)
      write(10,err=45) s,text(ntext),orga
      do 56 ia = 1,natom
      write(10,err=45) nsp(ia),(xmin(j,ia),j=1,3),mul(ia),le(ia),
     1 foccu(ia)
   56 continue
      if(long.eq.2) call PRINT(2,ior,natom,smin,xmin,mul,le)
   95 continue
      long = lsave
      endif
 
c     if no minimum found, error return :
      if(nr.eq.0) then
        write(*,25)
        write(nout,25)
   25   format(/' error in subroutine POLORG')
*       return 1
      endif
 
      return
   45 write(*,57)
      write(nout,57)
   57 format(//' ERROR  in POLORG while writing on unit 10')
      return 1
      end
*COPY ROTAT
      subroutine ROTAT(i)
c     called by STTNGS, subroutine of STIDY. Computes rotated or invert
c     atomcoordinates.
      PARAMETER(numat=150)
      common /ch/xa(3,numat)
      common /matr/ifmat,ifsh,ifplus,xmat(3,3),plus(3),sh(3),nabc,nsh,
     1 nshtra,ifnig,xmsave(3,3),shif(3),minsh
      common /rot/xrot(3,numat),natom
      dimension pl(3)
 
      do 10 j=1,3
      pl(j) = 2*plus(j)
    5 if(pl(j).gt..99999)  then
        pl(j) = pl(j) - 1.
        go to 5
      endif
   10 continue
 
      go to (51,52,53,54,55,56,56,58,59,60,61,62,63,64,65,66,67) ,i
 
*     for space groups 85, 86 & 88 settings yx-z & x-y-z give problem
*     if originshift for centrosymmetric setting: take negative shift.
*     put sh in shif in order to preserve original shift.
 
      do 1 j=1,3
    1 shif(j) = sh(j)
 
c   1: x y z
 
   51 do 36 ia = 1,natom
      do 36 j = 1,3
   36 xrot(j,ia) = xa(j,ia)
      return
c   2: -x y -z
   52 i1 = 1
      i2 = 3
      i3 = 2
      go to 20
c   3: -x -y z
   53 i1 = 1
      i2 = 2
      i3 = 3
      go to 20
c   4: x -y -z
   54 i1 = 2
      i2 = 3
      i3 = 1
      shif(2) = 1.-sh(2)
      shif(3) = 1.-sh(3)
*     ifsh = 2
   20 do 21 ia = 1,natom
      xrot(i1,ia) = 1.-xa(i1,ia)+pl(i1)
      xrot(i2,ia) = 1.-xa(i2,ia)+pl(i2)
      xrot(i3,ia) = xa(i3,ia)
   21 continue
      return
c   5: y x -z
   55 neg = 1
      shif(1) = sh(2)
      shif(2) = sh(1)
      shif(3) = 1.-sh(3)
      go to 23
c   6: -y -x -z
   56 neg = -1
   23 do 24 ia = 1,natom
      xrot(1,ia) = neg*xa(2,ia)
      xrot(2,ia) = neg*xa(1,ia)
      if(neg.eq.-1) then
        xrot(1,ia) = xrot(1,ia) + pl(1)
        xrot(2,ia) = xrot(2,ia) + pl(2)
       endif
      xrot(3,ia) = 1.-xa(3,ia)+pl(3)
   24 continue
      if(neg.eq.1) return
c   7: 1/4-y 1/4-x 1/4-z
      if(i.eq.7) then
        add = .25
        else
        add = 1.
        endif
      do 25 ia = 1,natom
      do 25 j = 1,3
   25 xrot(j,ia) = add + xrot(j,ia)
      return
c   8: -x 1/2-y -z
   58 do 27 ia = 1,natom
      xrot(1,ia) = 1.-xa(1,ia)+pl(1)
      xrot(2,ia) = .5-xa(2,ia)+pl(2)
   27 xrot(3,ia) = 1.-xa(3,ia)+pl(3)
      return
c   9: -y 1/2-x z
   59 do 28 ia = 1,natom
      xrot(1,ia) = 1. - xa(2,ia)+pl(2)
      xrot(2,ia) = .5 - xa(1,ia)+pl(3)
   28 xrot(3,ia) = xa(3,ia)
      return
c  10: 1/4-x 1/4-y 1/4-z
   60 do 30 ia = 1,natom
      do 30 j = 1,3
   30 xrot(j,ia) = .25 - xa(j,ia)+pl(j)
      return
c  11: -x -y -z
   61 do 29 ia = 1,natom
      do 29 j = 1,3
   29 xrot(j,ia) = 1.-xa(j,ia)+pl(j)
      return
c  12: x -y z
   62 do 26 ia = 1,natom
      do 26 j = 1,3,2
   26 xrot(j,ia) = xa(j,ia)
      xrot(2,ia) = 1.-xa(2,ia)+pl(2)
      return
c  13: x y -z
   63 do 31 ia = 1,natom
      do 31 j = 1,2
   31 xrot(j,ia) = xa(j,ia)
      xrot(3,ia) = 1.-xa(3,ia)+pl(3)
      return
c  14: -x 1/2-y 1/4-z
   64 do 32 ia = 1,natom
      xrot(1,ia) = 1.-xa(1,ia)+pl(1)
      xrot(2,ia) = .5-xa(2,ia)+pl(2)
   32 xrot(3,ia) = .25-xa(3,ia)+pl(3)
      return
c  15: -y -x z
   65 do 33 ia = 1,natom
      xrot(1,ia) = 1.-xa(2,ia)+pl(2)
      xrot(2,ia) = 1.-xa(1,ia)+pl(1)
   33 xrot(3,ia) = xa(3,ia)
      return
c  16: y x z
   66 do 34 ia = 1,natom
      xrot(1,ia) = xa(2,ia)
      xrot(2,ia) = xa(1,ia)
   34 xrot(3,ia) = xa(3,ia)
      return
c  17: 1/4+y 1/4+x 1/4+z
   67 do 35 ia = 1,natom
      xrot(1,ia) = .25 + xa(2,ia)
      xrot(2,ia) = .25 + xa(1,ia)
   35 xrot(3,ia) = .25 + xa(3,ia)
      return
 
      end
*COPY STTNGS
      subroutine STTNGS(keer,nn,ii)
c     called by MAIN of STIDY
c     rotation/inversion of coordinate system
 
      PARAMETER(numat=150)
      common /matr/ifmat,ifsh,ifplus,xmat(3,3),plus(3),sh(3),nabc,nsh,
     1 nshtra,ifnig,xmsave(3,3),shif(3),minsh
      common /rot/xrot(3,numat),natom
      common /stng/ irot,ntio
 
      dimension iar(4),nigar1(4),nigar2(4)
      data iar/6,5,3,1/,nigar1/19,18,5,1/,nigar2/21,20,15,11/
      if(nn.eq.0) then
        if(irot.lt.8) then
          if(keer.eq.2) then
            ii = 1
          else
            ii = irot
          endif
        else if(irot.eq.18.or.irot.eq.19) then
          ii = irot
          if(keer.eq.2) ii=1
        else if(irot.eq.20) then
          ii = nigar1(keer)
        else
         ii = iar(keer)
        endif
      else
        if(ntio.eq.1) then
          if(irot.lt.8) then
            if(keer.eq.2) then
              ii = 11
            else
              ii = 10+ irot
            endif
          else if(irot.eq.18.or.irot.eq.19) then
            ii = irot + 2
            if(keer.eq.2) ii = 11
          else if(irot.eq.20) then
            ii = nigar2(keer)
          else
            ii = iar(keer) + 10
          endif
        else if(ntio.eq.2) then
          ii = 8
          if(keer.eq.2) ii = 9
        else if(ntio.eq.3) then
          ii = 10
          if(keer.eq.2) ii = 17
        else if(ntio.eq.4) then
          ii = 14
        endif
 
      endif
      call ROTAT(ii)
 
*     put coordinates between 0 and 1:
      do 10 j=1,natom
      do 10 i=1,3
      if(xrot(i,j).gt..99999) xrot(i,j) = xrot(i,j)-1.
      if(xrot(i,j).lt.0.) xrot(i,j) = xrot(i,j) + 1.
   10 continue
      return
      end
