$LARGE
*COPY MAIN                                               13-11-1992
 
 
*                           STRUCTURE TIDY
 
c     Program to standardize structure data.
c     see Gelato & Parthe, J. Appl. Cryst. 1987,20,139-143.
 
*     idm = 1 : input from keyboard. Otherwise idm = 0.
      PARAMETER(numat=150,nelts=8,ntot=1000,iof=32,lc1=97,lc2=122)
*IBM  PARAMETER(numat=150,nelts=8,ntot=1000,iof=-64,lc1=129,lc2=169)
c     numat = max. number of atoms in asymmetric unit
c     nelts = max. number of different elements (for displacement and
c     Pearson code)
 
      common long,nout,idm,inf,isc,ipol,r,ngr,iocfl,vol,nfl,volrat
      common /at/iat,pos(3),ihex,fnum
      common /atch/elt1,elt2,f
      common/bl1/ sml, aa, bb, csh
      common /bl2/ specia(3,107)
      common /bl3/ text(21)
      common /bur/nt,spgr
      common /brz/ngo,ir(48,3,3),it(48,3),nbr
      common /cel/ a,b,c,al,be,ga,alf,bet,gam,cosa,cosb,cosg
      common /ch/xa(3,numat)
      common /garb/ ierr, igo, ired ,e1 ,ithru
      common /lab/ax
      common /matr/ifmat,ifsh,ifplus,xmat(3,3),plus(3),sh(3),nabc,nsh,
     1 nshtra,ifnig,xmsave(3,3),shif(3),minsh
      common /messa/ iw
      common /orgin/nor,orgadd(3,8),ntext,icoord
      common /par/ gmin
      common /pol/npol,xpol(3,ntot),xp(3,ntot),orga(3),smin,
     1 kkord(numat),nat(ntot)
      common /posi/x(3,192),dist(192),kount
      common /res/ atom1,atom2,foccu,intxt,code,elt
      common /rot/xrot(3,numat),natom
      common /sp/n,nw,ns(26),is(27),mult(15),nset(8),kset,mu,kord
      common /stng/ irot,ntio
      common /trans/s(3,3),u(9),t(9),p(9)
      common /trip/ dmin,min,korder(192),iflag,xmin(3,numat),
     1dis(numat),mul(numat),let(numat),nrset(numat),nnset(8,numat)
      common /xpolar/ ipolar,kpol(3),lowlet
 
      character elt1*2,atom1(numat)*2,csh(17)*14,sline*69
      character*1 nt(16),intext(70),sml(27),ansr,ko,intxt*40
      character aa(107)*11,bb(39)*15,text*17,f*5,foccu(numat)*5,ax*47
      character icel*51,code(2)*1,elt(nelts)*2,spgr*10,forms(15)*16
      character*4 elt2,atom2(numat),dat*50,line*73,eln(105)*2
      dimension finxyz(3,numat),shift(3,11),pear(nelts),
     1 iform(44),ssave(3,3),nsp(numat),orig(3),totsh(3)
      equivalence (icel,dat)
 
      data eln/'H ','He','Li','Be','B ','C ','N ','O ','F ','Ne','Na',
     1 'Mg','Al','Si','P ','S ','Cl','Ar','K ','Ca','Sc','Ti','V ',
     2 'Cr','Mn','Fe','Co','Ni','Cu','Zn','Ga','Ge','As','Se','Br','Kr',
     3 'Rb','Sr','Y ','Zr','Nb','Mo','Tc','Ru','Rh','Pd','Ag','Cd','In',
     4 'Sn','Sb','Te','I ','Xe','Cs','Ba','La','Ce','Pr','Nd','Pm','Sm',
     5 'Eu','Gd','Tb','Dy','Ho','Er','Tm','Yb','Lu','Hf','Ta','W ','Re',
     6 'Os','Ir','Pt','Au','Hg','Tl','Pb','Bi','Po','At','Rn','Fr','Ra',
     7 'Ac','Th','Pa','U ','Np','Pu','Am','Cm','Bk','Cf','Es','Fm','Md',
     8 'No','Lr','Tu','D '/
      data shift/5*0.75,2*0.,2*0.75,0.25,0.75,0.,5*0.25,0.,0.25,0.75,
     1 0.25,0.,0.75,0.125,0.,0.25,4*0.125,3*0.375/
      DATA IFORM/14,12,13,12,15,10,10,8,12,3,9,11,6,3,10,7,3,10,8,3,9,
     1 11,6,12,3,7,4*3,1,5,3*2,6,3,6,3,6,3,8,4,1/
      DATA FORMS/'Triclinic aP','Monoclinic mP','Monoclinic mC',
     1'Monoclinic mC(I)','Orthorhombic oP','Orthorhombic oC',
     2'Orthorhombic oF','Orthorhombic oI','Tetragonal tP',
     3'Tetragonal tI','Hexagonal hP','Rhombohedral hR','Cubic cP',
     4'Cubic cF','Cubic cI'/
 
      r = 180./3.14159265
      idm = 1
      istr = 0
 
      OPEN(UNIT=7,FILE='IN1.DAT',STATUS='OLD')
      OPEN(UNIT=8,FILE='SCRA1',FORM='BINARY')
      OPEN(UNIT=9,FILE='STIDY.OUT',STATUS='OLD')
      OPEN(UNIT=10,FILE='SCRA2',FORM='BINARY')
      OPEN(UNIT=11,FILE='IN.DAT',STATUS='OLD')
      OPEN(UNIT=12,FILE='SCRA3')
      OPEN(UNIT=13,FILE='SCRA4')
c     open direct access files:
      OPEN(UNIT=20,FILE='SETS.DAF',ACCESS= 'DIRECT',FORM = 'FORMATTED',
     1 RECL = 212,STATUS = 'OLD')
      OPEN(UNIT=21,FILE='SPGR.DAF',ACCESS= 'DIRECT',FORM = 'FORMATTED',
     1 RECL = 72,STATUS = 'OLD')
 
c     read technical details about input/output:
      call PRELIM(nigg,ifshif,orx,ory,orz)
      if(idm.eq.0) then
        inf = 7
      else
        inf = 5
  199   write(6,999)
        go to 2
      endif
    1 if(idm.eq.1) write(6,998)
    2 do 19 j=1,16
   19 nt(j) = ' '
      read(inf,3,end=100) intext
      if(intext(1).eq.'?') then

         write(*,798)
  798 format(' Two blanks are required between space group and',
     1' chemical formula.'/  
     2' For monoclinic and orthorhombic space groups, all',
     3' symbols listed'/' in Table 4.3.1 of the International',
     4' Tables for Crystallography,'/' Vol. A, are accepted, for',
     5' other crystal systems only standard'/' space group settings.',
     6' For trigonal space groups with R-type'/' Bravais lattice,',
     7' rhombohedral or hexagonal setting will be'/' recognized from',
     8' the cell parameters.'/)
         write(*,799)
  799 format(' Coding rules for space group symbols:'/
     1' The short form should be given, except for monoclinic system'/
     2' where both short and long forms are accepted. A space is'/
     3' required after the first letter, giving the Bravais lattice',
     4' and'/' between different symmetry directions. No space is',
     5' allowed'/' between symbols that give information about one',
     6' symmetry'/' direction. Write a bar as a minus sign in front',
     7' of the'/' corresponding number, and a subscript as a normal',
     8' number.'/' Examples: P 21,  P 1 21/c 1,  P n a m,',
     9'  P 63/m c m,  F d -3 m.')
         write(*,800)
  800 format(' If the space group symbol is preceded by * the',
     1' standardization'/' is performed in the Niggli-reduced cell.'//
     2' Type space group number (1 - 230) to see a list of acceptable'/
     3' settings written in the form which has to be used as input.')
         read(*,*) nspgr
         if(nspgr.gt.0.and.nspgr.le.230) then
  803      read(21,rec=nspgr,fmt=801) sline,iptr
           write(*,805) sline
           if(iptr.gt.0) then
              nspgr = iptr
              go to 803
           endif
        endif
        write(*,'( )')
        go to 199
      endif
  805 format(a69)
  801 format(a69,i3)
      istr = istr + 1
*     write END after former structure:
      if(istr.gt.1) write(nout,777)
  777 format('END')
      if(inf.eq.5) write(11,3) intext
 
*     initialize some flags. impcel =1 if imposed cell (+ before spcgrp)
      impcel = 0
      intxt = ' '
      j1 = 0
      ibl = 0
      nig = 0
      ic = 0
      mix = 0
*     mix=1 will indicate mixed atom-site has been read.
      do 4 j=1,70
      if(intext(j).eq.'*') then
        nig = 1
        intext(j) = ' '
        go to 4
      else if(intext(j).eq.'+') then
        impcel = 1
        intext(j) = ' '
        go to 4
      endif
      if(intext(j).eq.' ') then
         if(j1.eq.0) go to 4
        ibl = ibl + 1
        if(ibl.eq.2) go to 5
        j1 = j1 + 1
        nt(j1) = ' '
        go to 4
      endif
 
c     END or end: (remember: elements Er & Eu start with E)
      if(intext(j).eq.'E'.or.intext(j).eq.'e') then
        if(intext(j+1).eq.'N'.or.intext(j+1).eq.'n') go to 100
      endif
 
c     Put space group symbol in capital letters in array nt :
      k = ichar(intext(j))
      if(k.ge.lc1.and.k.le.lc2) k = k - iof
      j1 = j1 + 1
      if(j1.gt.16) go to 902
      nt(j1) = char(k)
      intext(j) = ' '
      ibl = 0
    4 continue
    5 continue
 
      mkord = 28
 
*     find where intext starts:
      int1 = 0
      do 1111 j=1,70
      if(intext(j).eq.' ') go to 1111
      int1 = j
      go to 1112
 1111 continue
 1112 intxt = ' '
      if(int1.gt.0) then
        do 1113 j=1,40
        intxt(j:j) = intext(int1-1+j)
 1113   continue
       endif
 
      if(long.gt.0) write(nout,11)  intxt, nt
      if(isc.eq.1.and.long.gt.0) write(*,11)  intxt, nt
   11 format(/' Input for ',a40/' Space group symbol : ',16A1/)
*     if(long.eq.0) write(*,1114)  intxt
*1114 format(//' ',a40)
      If(impcel.eq.1) then
        if(long.gt.0) write(nout,444)
        write(13,445) intxt
      else
        write(13,112)  intxt
      endif
      If(impcel.eq.1.and.isc.eq.1.and.long.gt.0)  write(*,444)
  444 format(' ------------------------------------------'/
     1' Standardization with imposed unit cell'/
     2' ------------------------------------------')
  112 format('DATA   ',a40)
  445 format('OTHER standardization with non-standard cell:'/
     1'DATA   ',a40)
 
c     initialisations:
   24 ifsh = 0
      ifplus = 0
      ifnig = 0
      ihex = 0
      iocfl = 0
      ko = ' '
      gmin = 1000000.
      volrat = 0.
      al =  0.
      be =  0.
      ga =  0.
      do 22 i=1,3
      plus(i) = 0.
      sh(i) = 0.
      do 22 j=1,3
      xmat(j,i) = 0.
   22 s(j,i) = 0.
      do 88 i=1,3
      xmat(i,i) = 1.
   88 s(i,i) = 1.
      code(1) = ' '
      code(2) = ' '
      ipears = 0
      pmin = 0.
      do 85 i=1,nelts
   85 pear(i) = 0.
      do 89 i=1,numat
      foccu(i) = ' '
   89 nrset(i) = 0
      ax = 'abc'
      nabc = 0
      nsh = 0
      nshtra = 0
c     nfl=1 indicates that setting -x,-y,-z is not considered
c     (case of enantiomorphic space group reduced to P1)
      nfl = 0
 
      if(ifshif.eq.1) ifsh = 1
      if(nigg.eq.1) nig = 1
 
c     Cell parameters:
  117 if(idm.eq.1.and.impcel.eq.0) write(6,7)
    7 format(' Cell parameters? (6 numbers) ')
      read(inf,'(a73)') line
      if(line(1:1).eq.'?') then
        write(*,820)
  820 format(' Six numbers should be separated by at least one space.'/)
        go to 117
      endif
*     use unit 12 for reading cell parameters (internal file is not
*     accepted by some compilers):
      rewind 12
      write(12,'(a73)') line
      rewind 12
      read(12,*) a,b,c,al,be,ga
      rewind 12
      if(inf.eq.5) write(11,9) a,b,c,al,be,ga
      if(long.gt.0) write(nout,8) a,b,c,al,be,ga
      if(isc.eq.1.and.long.gt.0)write(*,8) a,b,c,al,be,ga
    8 format(' Cell parameters : ',3f9.5,3f8.3/)
    9 format(6f10.5)
 
 
      call BURZ(ncs,ntrans,*902)
 
      if(long.gt.0) then
        if(nshtra.gt.0) write(nout,111) csh(nshtra)
        if(nshtra.gt.0.and.isc.eq.1)write(*,111) csh(nshtra)
  111 format(' Origin shift due to change of setting : ',a14)
      endif
 
c     read direct access file
      read (UNIT=20,FMT=14,REC=ngr) iw,irot,ntio,n,nw,ish,(ns(j),j=1,n),
     1 (is(l),l=1,n),(mult(k),k=1,nw)
   14 format(i3,2i1,3i2,67i3)
      is(n+1) = nw
 
      if(impcel.eq.1) go to 221
c-----back to cellparameters :
c     rhombohedral setting ?
      if(iw.eq.16) then
        if(al.gt.0..and.al.ne.90.) then
          if(long.gt.0) write(nout,918) a,al
          if(isc.eq.1.and.long.gt.0)write(*,918) a,al
  918 format(' Rhombohedral cell with a = ',f8.4,'   alpha = ',f8.4)
          call HEXA(a,al,ah,ch)
          ihex = 1
          a = ah
          c = ch
          ax = 'a-b,b-c,a+b+c'
          if(long.gt.0) write(nout,92) a,c
          if(isc.eq.1.and.long.gt.0)write(*,92) a,c
   92 format(' transformed to hexagonal cell : a = ',f8.4,'  c = ',f8.4)
          IFMAT = 2
          S(1,1) = 1.
          S(1,2) = 0.
          S(1,3) = 1.
          S(2,1) = -1.
          S(2,2) = 1.
          S(2,3) = 1.
          S(3,1) = 0.
          S(3,2) =-1.
          S(3,3) = 1.
          CALL INVERT(*900)
        endif
        if(ifmat.gt.0.and.long.eq.2)write(nout,13) ngr,spgr
        if(ifmat.gt.0.and.long.eq.2.and.isc.eq.1)write(*,13) ngr,spgr
      endif
   13 format(' Transformed to setting ',i3,2x,a10,'.')
 
c-----adjust cell parameters :
  221 call CELPA(ic,impcel)
      if(impcel.eq.1) go to 222
      if(ifmat.eq.2.) then
        call INVERT(*900)
        call AXES(s)
      endif
      iat = 0
 
ccc   option for Niggli-reduced cell :
 
      if(nig.eq.1) then
        vol1 = vol
        ish = 0
        iw = 1
        irot = 1
        do 120 i=1,3
        do 120 j=1,3
        ssave(j,i) = s(j,i)
  120   xmsave(j,i) = xmat(j,i)
        write(13,121)
  121   format('REMARK Niggli-reduced cell')
        ifnig = 0
        call CELRDN(ifnig)
        if(ifnig.eq.2) then
          call INVERT(*900)
          call AXES(s)
        endif
 
c     If originally changed from enantiomorphic space group, adjust S :
        IF(IFMAT.EQ.1) THEN
          DO 45 J=1,3
          DO 45 I=1,3
   45     S(I,J) = -S(I,J)
        ENDIF
 
c     adjust transformation matrix :
        do 41 i=1,3
        do 41 j=1,3
        k = (i-1)*3 + j
        u(k) = s(j,i)
   41   t(k) = ssave(j,i)
        call MATRIX(u,t,p)
        call AXES(p)
        if(long.eq.2) write(nout,122) ax
        if(long.eq.2.and.isc.eq.1)write(*,122) ax
  122 format(' total transformation = ',a/)
        call SYMTST(iseq)
        if(long.eq.2) write(nout,124) iseq,forms(iform(iseq))
        if(isc.eq.1.and.long.eq.2)write(*,124)iseq,forms(iform(iseq))
  124 format(/' Reduced form ',i2,' , which means metrically ',a/,
     1' Transformation matrix to a conventional basis is given in'/
     2' International Tables for Crystallography Vol.A, Table 9.3.1',
     3' (page 742)'/)
 
        if(long.eq.0) go to 125
        IF(ABS(A-B).LT.0.005) THEN
          WRITE(nout,930)
          if(isc.eq.1.) WRITE(*,930)
          IF(ABS(A-C).LT.0.005) THEN
            WRITE(nout,931)
            if(isc.eq.1) WRITE(*,931)
            WRITE(nout,932)
            if(isc.eq.1) WRITE(*,932)
          ENDIF
        ELSE IF(ABS(B-C).LT.0.005) THEN
          WRITE(nout,931)
          if(isc.eq.1) WRITE(*,931)
        ELSE IF(ABS(A-C).LT.0.005) THEN
          WRITE(nout,932)
          if(isc.eq.1) WRITE(*,932)
        ENDIF
 
  125   continue
        call NIGOPT(pear,ipears,pmin,kelt,ncs,ntio,*100)
        is(n+1) = nw
      vol=A *B *C *SQRT(1.0-COSG**2-COSB**2-COSA**2+2.0*COSA*COSB*COSG)
      volrat = vol/vol1
        go to 32
      endif
 
c     first letter of Pearson symbol :
  222 go to (101,102,103,104,105,106) ,ic
  101 code(1) = 'a'
      go to 108
  102 code(1) = 'm'
      go to 108
  103 code(1) = 'o'
      go to 108
  104 code(1) = 't'
      go to 108
  105 code(1) = 'h'
      go to 108
  106 code(1) = 'c'
c     second letter of Pearson symbol :
  108 ko = spgr(1:1)
      if(ko.eq.'A'.or.ko.eq.'C') ko = 'S'
      code(2) = ko
 
      if(impcel.eq.1) go to 333
      if(iw.ne.0.and.iw.ne.16)call MESS
      if(ifmat.eq.2.) then
        call INVERT(*900)
        call AXES(s)
      endif
      if(long.eq.0) go to 126
      if(nsh.gt.0) write(nout,109) csh(nsh)
      if(nsh.gt.0.and.isc.eq.1) write(*,109)csh(nsh)
      if(nabc.gt.0) write(nout,110) csh(nabc)
      if(nabc.gt.0.and.isc.eq.1) write(*,110)csh(nabc)
  110 format(' Extra origin shift due to interchange of axes : ',a14/)
  109 format(' Extra origin shift due to cell reduction : ',a14/)
 
c     If for a triclinic structure the axes are similar, give warning:
      IF(IW.EQ.1) THEN
        IF(ABS(A-B).LT.0.005) THEN
          WRITE(nout,930)
          if(isc.eq.1) WRITE(*,930)
          IF(ABS(A-C).LT.0.005) THEN
            WRITE(nout,931)
            if(isc.eq.1) WRITE(*,931)
            WRITE(nout,932)
            if(isc.eq.1) WRITE(*,932)
          ENDIF
        ELSE IF(ABS(B-C).LT.0.005) THEN
          WRITE(nout,931)
          if(isc.eq.1) WRITE(*,931)
        ELSE IF(ABS(A-C).LT.0.005) THEN
          WRITE(nout,932)
          if(isc.eq.1) WRITE(*,932)
        ENDIF
      ENDIF
  126 continue
 
ccc  extra originshift if structure not in setting with origin at centre
      if(ifsh.gt.0)then
        do 90 j=1,3
   90   sh(j) = shift(j,ish)
        if(long.gt.0) write(nout,91) csh(ish)
        if(isc.eq.1.and.long.gt.0) write(*,91) csh(ish)
   91   format(/' Origin shift of ',a14,' is applied in order to have'/
     1   ' the symmetry centre at the origin.'/)
       endif
 
  333 call ORIGIN(ngr)
 
*     ask for author & jrnl reference:
      if(idm.eq.1) then
  554   write(*,555)
        read(*,556) line
        if(line(1:1).eq.'?') then
          write(*,830)
  830 format(' Type one line of text for record "AUTHOR" or leave',
     1' blank.'/)
          go to 554
        endif
        if(line.ne.' ') write(13,557)  line
        if(line.ne.' '.and.inf.eq.5) write(11,557) line
  553   write(*,558)
        read(*,556) line
        if(line(1:1).eq.'?') then
          write(*,840)
  840 format(' Type one line of text for record "JRNL" or leave',
     1' blank.'/)
          go to 553
        endif
        if(line.ne.' ') write(13,559) line
        if(line.ne.' '.and.inf.eq.5) write(11,559) line
      endif
  555 format(' Author(s)?')
  556 format(a73)
  557 format('AUTHOR ',a73)
  558 format(' Reference?')
  559 format('JRNL   ',a73)
 
      natom = 0
      kelt = 0
      iend = 0
 
   15 call ATOM(nig,*37)
 
*     control element name for mixed site (only if not already found):
      if(mix.eq.1) go to 17
      do 16 i=1,105
      if(elt1.eq.eln(i)) go to 17
   16 continue
      mix = 1
*     Ask for definition of mixed sites:
      if(mix.eq.1.and.idm.eq.1) then
  552   write(*,666)
        read(*,556) line
        if(line(1:1).eq.'?') then
          write(*,850)
  850 format(' Type definition for mixed site(s) for record',
     1' "DEFINE" (one line).'/)
          go to 552
        endif
        write(13,668) line
        if(inf.eq.5) write(11,668) line
      endif
  666 format(' Occupation of mixed site(s)?')
  668 format('DEFINE ',a73)
      go to 17
   17 continue
 
      call POSIT
      kset = 0
 
      if(n.eq.0) then
        mu = mult(1)
        kord = 1
      if(long.eq.2) write(nout,44) mu,sml(1)
      if(long.eq.2.and.isc.eq.1) write(*,44) mu,sml(1)
   44 format(' General position ',i3,a1)
      else
        call SPEC(nig)
      endif
*     mkord gives highest symmetry site of structure.
      if(kord.lt.mkord) mkord = kord
 
c-----number of atoms for Pearson code :
      fmu = float(mu)
      fn = fnum * fmu
      pmin = pmin + fmu - fn
      ipears = ipears + mu
      if(kelt.gt.0) then
        do 86 i=1,kelt
        if(elt1.eq.elt(i)) go to 87
   86   continue
      endif
      kelt = kelt + 1
      if(kelt.gt.nelts) then
      write(nout,905) nelts
      write(*,905) nelts
  905 format(' More than ',i3,' different elements in structure,'/
     1' giving wrong Pearson code and displacements in output.')
*     Change variable NELTS in PARAMETER statement in MAIN, NIGOPT,
*     ORDER, PRINT, RENUM and RESULT  and resubmit job.
      kelt = kelt -1
      endif
      elt(kelt) = elt1
      i = kelt
   87 pear(i) = pear(i) + fn
      natom = natom + 1
      if(natom.gt.numat) go to 33
      kkord(natom) = kord
      atom1(natom) = elt1
      atom2(natom) = elt2
      foccu(natom) = f
      do 18 j=1,3
   18 xa(j,natom) = x(j,1)
 
      nrset(natom) = kset
      if(kset.gt.0) then
      do 65 i=1,kset
   65 nnset(i,natom) = nset(i)
      endif
 
c     next atom:
      go to 15
 
c   the program allows only NUMAT atoms in input.
   33 write(nout,34) numat
      write(*,34) numat
   34 format(' Too many atoms in input; the arrays are limited to ',
     1 i3,' atoms.')
*     If more atoms are needed, change value of NUMAT and NTOT in
*     PARAMETER statement in main program and in the following routines:
*     Choice, Nigopt, Order, Polar, Polorg, Print, Renum, Result, Rotat
*     and XYZ.
      if(idm.eq.0) go to 100
      go to 1
 
ccc   POLAR group ?
   37 ipol = 1
      icoord = 0
*     nor < 0 if polar group:
      if(nor.lt.0) then
        ipol = 0
   53   if(idm.eq.1) write(6,49)
   49 format(' Polar group. To compute the "best" origin type "Y",'/
     1 ' otherwise type "N" and the coordinates of the origin.')
 
        dat = ' '
        read(inf,51) ansr,dat
   51 format(a1,a50)
        if(ansr.eq.'?') then
          write(*,810)
  810 format(' If you do not wish the program to compute the "best"',
     1' origin'/' for the polar directions, type "N" and the',
     2' coordinates'/' of the origin in free format.'/)
          go to 53
        endif
        if(inf.eq.5) write(11,51) ansr,dat
        if(ansr.eq.'N'.or.ansr.eq.'n') then
          if(dat.eq.' ') then
            orga(1) = 0.
            orga(2) = 0.
            orga(3) = 0.
          else
            rewind 12
            write(12,52) dat
  52      format(a50)
            rewind 12
            read(12,*) orga
          endif
          ipol = 1
          nor = 1
          do 6 j=1,3
    6     orgadd(j,1) = orga(j)
          if(long.gt.0) write(nout,916) orga
          if(isc.eq.1.and.long.gt.0) write(*,916) orga
        endif
      endif
  916 format(' Polar group; imposed origin : ',3f9.5)
 
c     compute originshifts for polar groups:
   32 if(nor.lt.0) then
        nor2 = -nor
        ii = nor2/10
        nor = nor2-10*ii
        icoord = ii + 1
      endif
      nsave = nor
 
      rewind 10
 
c     Compute number of rotations of coordinate system
      nagain = 0
      keer = 1
      if(irot.gt.1.and.irot.lt.8) keer = 2
      if(irot.eq.8) keer = 4
      ksave = keer
 
c     Rotation/inversion of coordinate system:
   50 call STTNGS(keer,nagain,ntext)
      if(long.eq.2) write(nout,58) text(ntext)
      if(long.eq.2.and.isc.eq.1) write(*,58) text(ntext)
   58 format(//' ',a17/' -----------------')
      nor = nsave
      if(ipol.eq.0) then
        call POLAR(natom,mkord,icoord,*100)
      else
c     apply originshifts
        do 47 ior = 1,nor
        if(long.eq.2) write(nout,55) ior,(orgadd(j,ior),j=1,3)
        if(long.eq.2.and.isc.eq.1) write(*,55)ior,(orgadd(j,ior),j=1,3)
   55 format(//' origin shift ',i2,5x,3f9.5)
        sum = 0.
        do 62 ia = 1,natom
        elt1 = atom1(ia)
        elt2 = atom2(ia)
        do 46 j=1,3
        pos(j) = xrot(j,ia)-orgadd(j,ior)
        eps = -0.000001
        eps1 = 1. + eps
        if(pos(j).lt.eps) pos(j) = pos(j) + 1.
        if(pos(j).ge.eps1) pos(j) = pos(j) - 1.
   46   continue
        call POSIT
 
        if(long.eq.2) write(nout,38) elt1,elt2
        if(long.eq.2.and.isc.eq.1) write(*,38) elt1,elt2
   38 format(//' Atom ',a2,1x,a4)
c     choose representative triplet.
        kord = 0
        ipolar = 0
        call XYZ (ia,np,*39)
        nsp(ia) = np
   39   if(iflag.eq.1.and.long.gt.0) then
          write(nout,38) elt1,elt2
          if(isc.eq.1)write(*,38) elt1,elt2
          write(nout,20)
          if(isc.eq.1) then
            write(*,38) elt1,elt2
            write(*,20)
          endif
   20 format(' No permitted choice of coordinate triplet.')
          go to 47
        endif
        do 57 j=1,3
   57   finxyz(j,ia) = x(j,min)
        mul(ia) = mu
        let(ia) = kord
        sum = sum + dmin
   62   continue
 
        do 64 i=1,3
   64   orig(i) = orgadd(i,ior)
 
*     take care of total originshift: for some groups shif and not sh:
        ifs = 1
        if(ngr.eq.85.or.ngr.eq.86.or.ngr.eq.88) then
          if(text(ntext)(1:7).eq.'x,-y,-z'.or.text(ntext)(1:6).eq.
     1    'y,x,-z') ifs = 2
        else
           ifs = 1
        endif
        if(ifsh.gt.0.or.ifplus.gt.0) then
          do 60 i = 1,3
          if(ifs.eq.1) totsh(i) = plus(i) + sh(i)
          if(ifs.eq.2) totsh(i) = plus(i) + shif(i)
          if(totsh(i).ge..9999) totsh(i) = totsh(i) - 1.
          orig(i) = orig(i) + totsh(i)
          if(orig(i).ge..9999) orig(i) = orig(i) - 1.
   60     continue
          if(minsh.gt.0) then
            orig(minsh) = orig(minsh) -2*totsh(minsh)
            if(orig(minsh).lt.0.) then
  162         orig(minsh) = orig(minsh) + 1.
              if(orig(minsh).lt.0.) go to 162
            endif
          endif
        endif
c     minimum gamma :
        if(sum.lt.gmin)   gmin = sum
 
        if(long.eq.2)
     1  call PRINT(1,ior,natom,sum,finxyz,mul,let)
 
        write(10,err=96) sum,text(ntext),(orig(k),k=1,3)
        do 59 i = 1,natom
        write(10,err=96)nsp(i),(finxyz(j,i),j=1,3),mul(i),let(i),
     1  foccu(i)
   59   continue
   47   continue
      endif
 
      keer = keer - 1
      if(keer.gt.0) go to 50
      if(ntio.eq.0.or.nagain.eq.1) go to 70
      keer = ksave
      nagain = 1
      go to 50
 
   70 call RESULT(natom,ihex,ipears,pmin,pear,kelt)
 
      go to 1
 
   96 write(nout,42)
      write(*,42)
   42 format(//' ERROR  in MAIN while writing on unit 10')
      if(idm.eq.1) go to 1
      go to 100
 
  902  if(idm.eq.1) then
        write(6,21)
        write(nout,10)
   21 format(' Invalid space group symbol. Try again.')
        go to 1
       else
        write(nout,10)
        stop
      endif
   10 format(' Invalid space group symbol. Stop job.')
 
  900 write(nout,901)
      write(*,901)
  901 format(/' Error in subroutine INVERT; determinant = 0. Stop job.')
      if(idm.eq.1) go to 1
      go to 100
 
  100 continue
*     write(nout,777)
      write(nout,107)
  107 format(//'End of STIDY')
      CLOSE(7,STATUS='DELETE')
      CLOSE(8,STATUS='DELETE')
      CLOSE(9)
      close(10,STATUS='DELETE')
      CLOSE(11)
      CLOSE(12,STATUS='DELETE')
      CLOSE(13,STATUS='DELETE')
      CLOSE(20)
      CLOSE(21)
      STOP
 
    3 format(70a1)
  930 FORMAT(' WARNING : Axes a and b of reduced cell are very',
     1' similar.'/)
  931 FORMAT(' WARNING : Axes b and c of reduced cell are very',
     1' similar.'/)
  932 FORMAT(' WARNING : Axes a and c of reduced cell are very',
     1' similar.'/)
  998 format(/' Next structure. Give space group symbol or write END.')
  999 format(' Hermann-Mauguin symbol for space group and',
     1' as option chemical formula?')
 
      end
*COPY BLOCKDATA
      BLOCKDATA
 
      CHARACTER sml(27)*1,aa(107)*11,bb(39)*15,text(21)*17,csh(17)*14
 
      COMMON/bl1/ sml, aa, bb , csh
      COMMON /bl2/ specia(3,107)
      common /bl3/text
 
      DATA sml/'a','b','c','d','e','f','g','h','i','j','k','l','m','n',
     1'o','p','q','r','s','t','u','v','w','x','y','z','*'/
      DATA specia/3*.5,0.,3*.5,0.,3*.5,0.,.5,3*0.,.5,3*0.,.5,3*0.,2*.25,
     1.5,2*.25,0.,2*.25,.75,4*.25,.75,.25,.75,2*.25,2*.5,.25,0.,.5,.25,
     2.5,0.,.25,2*0.,3*.25,.5,.75,.25,.5,.75,.25,0.,2*.25,0.,.25,.75,0.,
     3.25,2*0.,.25,0.,.5,0.,2*.25,0.,.25,.75,3*.125,.25,0.,.25,2*.125,
     4.625,0.,.5,.75,.25,.75,.5,0.,.25,.125,0.,.25,.625,.25,3*.75,.25,
     5.75,0.,.75,.125,0.,.25,.375,.33333,.66667,0.,.33333,.66667,.5,
     6.66667,.33333,0.,.66667,.33333,.5,.33333,.66667,.25,.66667,.33333,
     7.25,.33333,.66667,4*.75,3*.625,.25,.5,0.,3*.375,3*.875,.125,0.,.25
     8,.625,0.,.25,.375,0.,.25,.875,0.,.25,0.,.75,.25,.5,.25,.75,.875,
     92*.125,-1.,2*.5,-1.,.5,0.,-1.,0.,.5,-1.,2*0.,-1.,2*.25,-1.,0.,.25,
     A-1.,.25,.75,-1.,.5,.25,-1.,.25,.5,-1.,.25,0.,-1.,2*.125,-1.,.25,
     B.125,-1.,.75,.25,-1.,0.,.33333,-1.,0.,.83333,-1.,0.,.66667,-1.,0.,
     C.16667,.5,-1.,.5,0.,-1.,2*.5,-1.,2*0.,-1.,0.,.5,-1.,.25,0.,-1.,
     D2*.25,-1.,2*.25,-1.,0.,.75,-1.,2*.25,-1.,.5,.125,-1.,.125,2*.5,-1.
     E,0.,.5,-1.,.5,0.,-1.,2*0.,-1.,2*.25,-1.,0.,.25,-1.,.25,.75,-1.,.25
     F,.5,-1.,.25,0.,-1.,2*.125,-1.,.75,.25,-1.,.33333,.66667,-1.,.66667
     G,.33333,-1.,2*-1.,.5,2*-1.,0.,2*-1.,.25,-1.,.5,2*-1.,0.,2*-1.,.25,
     H-1.,.5,2*-1.,0.,2*-1.,.25,2*-1./
      DATA aa(1)/'1/2 1/2 1/2'/,aa(2)/'0 1/2 1/2  '/,aa(3)/'1/2 0 1/2  '
     1/,aa(4)/'1/2 1/2 0  '/,aa(5)/'1/2 0 0    '/,aa(6)/'0 1/2 0    '/,
     2   aa(7)/'0 0 1/2    '/,aa(8)/'0  0  0    '/,aa(9)/'1/4 1/4 1/2'/,
     3aa(10)/'1/4 1/4 0  '/,aa(11)/'1/4 1/4 3/4'/,aa(12)/'1/4 1/4 1/4'/,
     4aa(13)/'1/4 3/4 1/4'/,aa(14)/'3/4 1/4 1/4'/,aa(15)/'1/2 1/2 1/4'/,
     5aa(16)/'0 1/2 1/4  '/,aa(17)/'1/2 0 1/4  '/,aa(18)/'0 0 1/4    '/,
     6aa(19)/'1/4 1/4 1/2'/,aa(20)/'3/4 1/4 1/2'/,aa(21)/'3/4 1/4 0  '/,
     7aa(22)/'1/4 1/4 0  '/,aa(23)/'1/4 3/4 0  '/,aa(24)/'1/4 0 0    '/,
     8aa(25)/'1/4 0 1/2  '/,aa(26)/'0 1/4 1/4  '/,aa(27)/'0 1/4 3/4  '/,
     9aa(28)/'1/8 1/8 1/8'/,aa(29)/'1/4 0 1/4  '/,aa(30)/'1/8 1/8 5/8'/,
     aaA(31)/'0 1/2 3/4  '/,aa(32)/'1/4 3/4/1/2'/,aa(33)/'0 1/4 1/8  '/,
     Baa(34)/'0 1/4 5/8  '/,aa(35)/'1/4 3/4 3/4'/,aa(36)/'3/4 1/4 3/4'/,
     Caa(37)/'0 3/4 1/8  '/,aa(38)/'0 1/4 3/8  '/,aa(39)/'1/3 2/3 0  '/,
     Daa(40)/'1/3 2/3 1/2'/,aa(41)/'2/3 1/3 0  '/,aa(42)/'2/3 1/3 1/2'/,
     Eaa(43)/'1/3 2/3 1/4'/,aa(44)/'2/3 1/3 1/4'/,aa(45)/'1/3 2/3 3/4'/,
     Faa(46)/'3/4 3/4 3/4'/,aa(47)/'5/8 5/8 5/8'/,aa(48)/'1/4 1/2 0  '/,
     Gaa(49)/'3/8 3/8 3/8'/,aa(50)/'7/8 7/8 7/8'/,aa(51)/'1/8 0 1/4  '/,
     Haa(52)/'5/8 0 1/4  '/,aa(53)/'3/8 0 1/4  '/,aa(54)/'7/8 0 1/4  '/,
     Iaa(55)/'0 3/4 1/4  '/,aa(56)/'1/2 1/4 3/4'/,aa(57)/'7/8 1/8 1/8'/,
     Jaa(58)/'x 1/2 1/2  '/,aa(59)/'x 1/2 0    '/,aa(60)/'x 0 1/2    '/
      DATA aa(61)/'x 0 0      '/,aa(62)/'x 1/4 1/4  '/,
     1aa(63)/'x 0 1/4    '/,aa(64)/'x 1/4 3/4  '/,aa(65)/'x 1/2 1/4  '/,
     2aa(66)/'x 1/4 1/2  '/,aa(67)/'x 1/4 0    '/,aa(68)/'x 1/8 1/8  '/,
     3aa(69)/'x 1/4 1/8  '/,aa(70)/'x 3/4 1/4  '/,aa(71)/'x 0 1/3    '/,
     4aa(72)/'x 0 5/6    '/,aa(73)/'x 0 2/3    '/,aa(74)/'x 0 1/6    '/,
     5aa(75)/'1/2 y 1/2  '/,aa(76)/'0 y 1/2    '/,aa(77)/'1/2 y 0    '/,
     6aa(78)/'0 y 0      '/,aa(79)/'1/2 y 1/4  '/,aa(80)/'0 y 1/4    '/,
     7aa(81)/'1/4 y 1/4  '/,aa(82)/'1/4 y 0    '/,aa(83)/'3/4 y 1/4  '/,
     8aa(84)/'1/4 y 1/2  '/,aa(85)/'1/8 y 1/8  '/,aa(86)/'1/2 1/2 z  '/,
     9aa(87)/'0 1/2 z    '/,aa(88)/'1/2 0 z    '/,aa(89)/'0 0 z      '/,
     aaA(90)/'1/4 1/4 z  '/,aa(91)/'0 1/4 z    '/,aa(92)/'1/4 3/4 z  '/,
     Baa(93)/'1/4 1/2 z  '/,aa(94)/'1/4 0 z    '/,aa(95)/'1/8 1/8 z  '/,
     Caa(96)/'3/4 1/4 z  '/,aa(97)/'1/3 2/3 z  '/,aa(98)/'2/3 1/3 z  '/,
     D aa(99)/'x y 1/2    '/,aa(100)/'x y 0      '/,
     E aa(101)/'x y 1/4    '/,aa(102)/'x 1/2 z    '/,
     F aa(103)/'x 0 z      '/,aa(104)/'x 1/4 z    '/,
     G aa(105)/'1/2 y z    '/,aa(106)/'0 y z      '/,
     H aa(107)/'1/4 y z    '/
      DATA bb(1)/'x x 0          '/,bb(2)/'x x 1/2        '/,
     1 bb(3)/'x x 1/4        '/,bb(4)/'x x 3/4        '/,
     2 bb(5)/'x x 3/8        '/,bb(6)/'x x 5/8        '/,
     3 bb(7)/'x -x 0         '/,bb(8)/'x -x 1/2       '/,
     4 bb(9)/'x -x 1/4       '/,bb(10)/'x -x 1/3       '/,
     5 bb(11)/'x -x 2/3       '/,bb(12)/'x -x 1/6       '/,
     6 bb(13)/'x -x 5/6       '/,bb(14)/'x 1/2+x 1/4    '/,
     7 bb(15)/'x 1/2+x 1/2    '/,bb(16)/'x 1/2+x 0      '/,
     8 bb(17)/'x 1/2-x 1/4    '/,bb(18)/'x 1/4+x 1/8    '/,
     9 bb(19)/'x 1/4+x 7/8    '/,bb(20)/'x 2x 0         '/,
     A bb(21)/'x 2x 1/2       '/,bb(22)/'x 2x 1/4       '/,
     B bb(23)/'x 2x 3/4       '/,bb(24)/'0 y y          '/,
     C bb(25)/'1/2 y y        '/,bb(26)/'1/4 y y        '/,
     D bb(27)/'0 y -y         '/,bb(28)/'1/4 y -y       '/,
     E bb(29)/'1/4 y 1/2+y    '/,bb(30)/'1/4 y 1/2-y    '/,
     F bb(31)/'1/2 y 1/2+y    '/,bb(32)/'1/2 y -y       '/,
     G bb(33)/'1/8 y 1/4+y    '/,bb(34)/'1/8 y 1/4-y    '/,
     H bb(35)/'x x x          '/,bb(36)/'x x z          '/,
     I bb(37)/'x -x z         '/,bb(38)/'x 1/2+x z      '/,
     J bb(39)/'x 2x z         '/
c
      data csh/'3/4 3/4 3/4','3/4 3/4 0','0 3/4 3/4','1/4 3/4 0',
     1 '1/4 1/4 1/4','1/4 1/4 0','1/4 3/4 1/4','0 3/4 1/8',
     2 '0 1/4 1/8','1/8 1/8 1/8','3/8 3/8 3/8','1/4 0 1/4','1/4 1/4 3/4'
     3,'3/4 1/4 1/4','0 1/4 1/4','0 0 1/4','0 1/4 0'/
      DATA text/'x,y,z','-x,y,-z','-x,-y,z','x,-y,-z','y,x,-z',
     1 '-y,-x,-z','1/4-y,1/4-x,1/4-z','-x,1/2-y,-z','-y,1/2-x,z',
     2 '1/4-x,1/4-y,1/4-z','-x,-y,-z','x,-y,z','x,y,-z',
     3 '-x,1/2-y,1/4-z','-y,-x,z','y,x,z','1/4+y,1/4+x,1/4+z',
     4 'x,-z,y','-z,y,x','-x,z,-y','z,-y,-x'/
      END
*COPY MATRIX
      SUBROUTINE MATRIX (U,T,P)
C
C        **********MULTIPLY TWO 3X3 MATRICES**********
C
C                  (T-MATRIX)
C       (U-MATRIX) (P-MATRIX)
C
      DIMENSION U(9),T(9),P(9)
      P(1)=T(1)*U(1)+T(4)*U(2)+T(7)*U(3)
      P(2)=T(2)*U(1)+T(5)*U(2)+T(8)*U(3)
      P(3)=T(3)*U(1)+T(6)*U(2)+T(9)*U(3)
      P(4)=T(1)*U(4)+T(4)*U(5)+T(7)*U(6)
      P(5)=T(2)*U(4)+T(5)*U(5)+T(8)*U(6)
      P(6)=T(3)*U(4)+T(6)*U(5)+T(9)*U(6)
      P(7)=T(1)*U(7)+T(4)*U(8)+T(7)*U(9)
      P(8)=T(2)*U(7)+T(5)*U(8)+T(8)*U(9)
      P(9)=T(3)*U(7)+T(6)*U(8)+T(9)*U(9)
      RETURN
      END
*COPY RESET
      SUBROUTINE RESET
C
C        *****UPDATE TOTAL TRANSFORMATION MATRIX*****
C                CALLED AFTER MATRIX SUBROUTINE
C
      COMMON/TRANS/ uvw(9),U(9),T(9),P(9)
      do 1 i=1,9
    1 uvw(i) = p(i)
      RETURN
      END
*COPY PRELIM
      subroutine PRELIM(nig,ifsh,orx,ory,orz)
c     called by MAIN of STIDY
      common long,nout,idm,inf,isc,ipol,r,ngr,iocfl,vol,nfl,volrat
      character ansr*1
 
      nout = 9
      idm = 1
      isc = 0
      long = 0
      nig = 0
      ifsh = 0
      ipol = 0
      orx= 0
      ory = 0
      orz = 0
 
    1 write(*,11)
   11 format(' Program STRUCTURE TIDY.  For help, type "?".'/
     1' Short, normal or long output? (S/N/L)')
      read(*,2) ansr
    2 format(a1)
      if(ansr.eq.'?') then
        write(*,799)
  799 format(' Options for output:'/' SHORT   Chemical formula,',
     1' standardized data set (space group,'/'         Wyckoff',
     2' sequence, Pearson code, standardization para-'/
     3'         meters gamma and CG, cell parameters, atom',
     4' coordinates),'/'         transformations applied by the',
     5' standardization procedure,'/'         authors and reference.'/
     6' NORMAL  In addition to SHORT, input data and information',
     7' about'/'         change of space group setting, cell',
     8' reduction, origin'/'         shifts.')
        write(*,800)
  800 format(' LONG    In addition to NORMAL, detailed information',
     1' about the'/'         calculations, data sets for all possible',
     2' rotations,'/'         inversion and space group permitted',
     3' origin shifts tested'/'         by the standardization',
     4' procedure.'/)
        go to 1
      endif
      long = 1
      if(ansr.eq.'S'.or.ansr.eq.'s') then
        long = 0
      else if(ansr.eq.'L'.or.ansr.eq.'l') then
        long = 2
      endif
    5 write(*,6)
    6 format(' Input from keyboard or from file? (K/F)')
      read(*,2) ansr
      if(ansr.eq.'?') then
         write(*,810)
  810 format(' Using keyboard "K" a file IN.DAT will be created,'/
     1' which has the following format:'/
     2' P n m a  Y Ni Al3'/' 8.156 4.0462 10.638 90. 90. 90.'/
     3' AUTHOR Gladyshevskii R.E., Parthe E.'/' JRNL   92ACSCE 48',
     4' 229-232'/' Y .1860 1/4 .0088'/' Ni .1070 1/4 .3569'/
     5' Al1 .0540 1/4 .5835'/' Al2 .3565 1/4 .7215'/' Al3 .3853',
     6' 1/4 .2860'/' end'/' end'/
     7' The file IN.DAT can be used to run the program in option "F".'/)
         go to 5
      endif
      if(ansr.eq.'F'.or.ansr.eq.'f') idm = 0
   10 write(*,12)
   12 format(' Do you want output on screen? (Y/N)' )
      read(*,2) ansr
      if(ansr.eq.'?') then
        write(*,820)
  820 format(' Output is also on file STIDY.OUT.'/)
        go to 10
      endif
      if(ansr.eq.'Y'.or.ansr.eq.'y') isc = 1
 
      return
      end
*COPY ORIGIN
      subroutine ORIGIN(num)
c     called by main program of STIDY
c     contains information about originshifts.
 
      common /orgin/nor,orgadd(3,8),ntext,icoord
      dimension igroup(230)
      data igroup/ 10,1,17,17,18,19,19,20,20,1,1,6,1,1,6,1,1,1,1,6,6,7,
     1 2*6,10*11,3*12,4*13,2*14,3*12,
     2 16*1,6*6,4,4,4*6,4*15,2*14,2,8,4*2,3,3,8*2,3,3,8*15,4*14,8*2,
     3 8,8,3,3,16*2,4*3,3*16,14,3,3,5,3,5,3,5,3,3,16,14,16,3*14,6*3,6*14
     4 ,5,8*3,4*14,5,5,6*3,4,7,9,4,9,4*4,9,4,9,4*4,9,4,4,9,4,7,9,4,7,9,
     5 8*4,9,9/
 
      do 1100 i=1,8
      do 1100 j=1,3
 1100 orgadd(j,i) = 0.
      igr = igroup(num)
      go to (1001,1002,1003,1004,1005,1006,1007,1008,1009,1010,1011,1012
     1 ,1013,1014,1015,1016,1017,1018,1019,1020) ,igr
 
c     x y z
 1010 nor = -31
      go to 1030
c-----0 0 0, 1/2 0 0, 0 1/2 0, 0 0 1/2, 0 1/2 1/2, 1/2 0 1/2, 1/2 1/2 0,
c     1/2 1/2 1/2
 1001 nor = 8
      orgadd(1,2) = .5
      orgadd(2,3) = .5
      orgadd(3,4) = .5
      orgadd(2,5) = .5
      orgadd(3,5) = .5
      orgadd(1,6) = .5
      orgadd(3,6) = .5
      orgadd(1,7) = .5
      orgadd(2,7) = .5
      orgadd(1,8) = .5
      orgadd(2,8) = .5
      orgadd(3,8) = .5
      go to 1030
c-----0 0 0, 0 0 1/2, 1/2 1/2 0, 1/2 1/2 1/2
 1002 nor = 4
      orgadd(3,2) = .5
      orgadd(1,3) = .5
      orgadd(2,3) = .5
      orgadd(1,4) = .5
      orgadd(2,4) = .5
      orgadd(3,4) = .5
      go to 1030
c-----0 0 0, 0 0 1/2
 1003 nor = 2
      orgadd(3,2) = .5
      go to 1030
c-----0 0 0, 1/2 1/2 1/2
 1004 nor = 2
      orgadd(1,2) = .5
      orgadd(2,2) = .5
      orgadd(3,2) = .5
      go to 1030
c-----0 0 0, 0 0 1/2, 1/3 2/3 0, 1/3 2/3 1/2, 2/3 1/3 0, 2/3 1/3 1/2
 1005 nor = 6
      orgadd(3,2) = .5
      orgadd(1,3) = 1./3.
      orgadd(2,3) = 2./3.
      orgadd(1,4) = 1./3.
      orgadd(2,4) = 2./3.
      orgadd(3,4) = .5
      orgadd(1,5) = 2./3.
      orgadd(2,5) = 1./3.
      orgadd(1,6) = 2./3.
      orgadd(2,6) = 1./3.
      orgadd(3,6) = .5
      go to 1030
c-----0 0 0, 0 0 1/2, 0 1/2 0, 0 1/2 1/2
 1006 nor = 4
      orgadd(3,2) = .5
      orgadd(2,3) = .5
      orgadd(2,4) = .5
      orgadd(3,4) = .5
      go to 1030
c-----0 0 0, 1/4 1/4 1/4, 1/2 1/2 1/2, 3/4 3/4 3/4
 1007 nor = 4
      orgadd(1,2) = .25
      orgadd(2,2) = .25
      orgadd(3,2) = .25
      orgadd(1,3) = .5
      orgadd(2,3) = .5
      orgadd(3,3) = .5
      orgadd(1,4) = .75
      orgadd(2,4) = .75
      orgadd(3,4) = .75
      go to 1030
c-----0 0 0, 0 0 1/2, 0 1/2 1/4, 0 1/2 3/4
 1008 nor = 4
      orgadd(3,2) = .5
      orgadd(2,3) = .5
      orgadd(3,3) = .25
      orgadd(2,4) = .5
      orgadd(3,4) = .75
      go to 1030
c-----0 0 0
 1009 nor = 1
      go to 1030
c-----0 0 z, 0 1/2 z, 1/2 0 z, 1/2 1/2 z
 1011 nor = -4
      orgadd(2,2) = .5
      orgadd(1,3) = .5
      orgadd(1,4) = .5
      orgadd(2,4) = .5
      go to 1030
 
c     0 0 z, 0 1/2 z
 1012 nor = -2
      orgadd(2,2) = .5
      go to 1030
 
c     0 0 z, 1/2 0 z
 1013 nor = -2
      orgadd(1,2) = .5
      go to 1030
 
c     0 0 z
 1014 nor = -1
      go to 1030
 
c     0 0 z, 1/2 1/2 z
 1015 nor = -2
      orgadd(1,2) = .5
      orgadd(2,2) = .5
      go to 1030
 
c     0 0 z, 1/3 2/3 z, 2/3 1/3 z
 1016 nor = -3
      orgadd(1,2) = 1./3.
      orgadd(2,2) = 2./3.
      orgadd(1,3) = 2./3.
      orgadd(2,3) = 1./3.
      go to 1030
 
c     0 y 0, 0 y 1/2, 1/2 y 0, 1/2 y 1/2
 1017 nor = -14
      orgadd(3,2) = .5
      orgadd(1,3) = .5
      orgadd(1,4) = .5
      orgadd(3,4) = .5
      go to 1030
 
c     0 y 0, 0 y 1/2
 1018 nor = -12
      orgadd(3,2) = .5
      go to 1030
 
c     x 0 z, x 1/2 z
 1019 nor = -22
      orgadd(2,2) = .5
      go to 1030
 
c     x 0 z
 1020 nor = -21
      go to 1030
 
 1030 return
      end
*COPY CELPA
      subroutine CELPA(ic,impcel)
c     called from MAIN
c-----adjust cell parameters and compute volume of unit cell
c     ic = 1..6 means: a,m,o,t,h,c
      common long,nout,idm,inf,isc,ipol,r,ngr,iocfl,vol,nfl,volrat
      common /cel/ a,b,c,al,be,ga,alf,bet,gam,cosa,cosb,cosg
      common /matr/ifmat,ifsh,ifplus,xmat(3,3),plus(3),sh(3),nabc,nsh,
     1 nshtra,ifnig,xmsave(3,3),shif(3),minsh
      common /trans/s(3,3),u(9),t(9),p(9)
      vol = 0.
      alf = al/r
      bet = be/r
      gam = ga/r
      cosb = cos(bet)
      if(ngr.le.2) then
        ic = 1
        cosa = cos(alf)
        cosg = cos(gam)
        v = 1.-cosa**2-cosb**2-cosg**2+2.*cosa*cosb*cosg
        if(v.gt.0.0001) vol = a*b*c*sqrt(v)
      else
        al = 90.
        ga = 90.
        cosa = 0.
        cosg = 0.
        alf = 90./r
        gam = alf
        if(ngr.ge.3.and.ngr.le.15) then
          ic = 2
          vol = a*b*c*sin(bet)
          if(impcel.eq.1) return
          if(be.lt.90.) then
            be = 180.-be
            bet = be/r
            cosb = -cosb
            ifmat = 2
            do 15 i=1,9
   15       u(i) = 0.
            u(1) = -1.
            u(5) = -1.
            u(9) = 1.
            call MATRIX(u,s,p)
            call RESET
            if(long.gt.1) write(nout,10) be
   10 format(' In order to obtain obtuse angle beta, transform axes',
     1' by -a,-b,c'/' new beta = ',f8.3)
          endif
        else
          be = 90.
          cosb = 0.
          bet = 90./r
          if(ngr.ge.16.and.ngr.le.74) then
             ic = 3
             vol = a*b*c
          else
            b = a
            if(ngr.ge.75.and.ngr.le.142) then
            ic = 4
            vol = a*a*c
            else if(ngr.ge.143.and.ngr.le.194) then
            ga = 120.
            gam = ga/r
            cosg = -.5
            ic = 5
            vol = 0.866*a*a*c
            else if(ngr.ge.195) then
            c = a
            ic = 6
            vol = a**3
            endif
          endif
        endif
      endif
      if(vol.lt.0.0001.and.long.gt.0) then
        write(nout,99)
        if(isc.eq.1)write(*,99)
   99 format(' parameters do not define valid cell ')
      endif
 
      return
      end
*COPY HEXA
      subroutine HEXA(ar,alfa,ah,ch)
c     computes hexagonal cell parameters from rhombohedral input
 
      alfa = alfa*3.14159/180.
      ah = 2.*ar*sin(.5*alfa)
      ch = 1.73205*ar*sqrt(1.+2.*cos(alfa))
 
      return
      end
*COPY BURZ
      subroutine BURZ(ncs,ntrans,*)
c     adapted from program SYMOP (H.Burzlaff & H.Zimmermanm (1984),
c     Z. Kristallogr. 167, pp 89-102)
      common long,nout,idm,inf,isc,ipol,rr,ngr,iocfl,vol,nfl,volrat
      common /brz/ngo,r,t,nbr
      common /bur/ nt,spgr
      common /matr/ifmat,ifsh,ifplus,xmat(3,3),plus(3),sh(3),nabc,nsh,
     1 nshtra,ifnig,xmsave(3,3),shif(3),minsh
      common /trans/ss(9),dummy(27)
      character*1 HBR(7),HS(14),NT(16),UP(6),low(6)
      character*10 spgr,spg(230),aux*17
 
      INTEGER SYS,GES(3,3,36),NET(3),IN(7),GET(3,25),NT1(1623),
     *IS(14),S(3),LGT(48),NT2(45),cent(230),Z,MM(43,3),M4(20,18)
     *,LF(216),Q(3,4,5),SEM(3,3,18),SC(3,3),LGN(3,45),SY(45),
     *T(48,3),R(48,3,3),tgrp(541),trafo(541),NGT(48,48),LIST(230)
      dimension abc(9,30)
 
      DATA UP/'A','B','C','D','M','N'/
      DATA LOW/'a','b','c','d','m','n'/
      DATA SEM/1,3*0,1,3*0,1,96,3*0,1,3*0,1,1,3*0,96,3*0,1,1,3*0,1,3*0,9
     *6,1,3*0,96,3*0,2*96,3*0,1,3*0,2*96,3*0,96,3*0,1,96,3*0,96,3*0,3*96
     *,3*0,1,3*0,2*96,3*0,96,5*0,96,6*0,3*96,8*0,1,6*0,64,128,32,6*0,128
     *,64,3*0,1,3*0,128,64,3*0,96,3*0,3*48,96,3*0,96,0,2*96,2*0,96,48,2*
     *0,96/
      DATA NT2/0,1,14,40,53,58,68,73,107,141,175,192,194,200,212,218,224
     *,234,238,242,244,248,251,252,258,262,264,266,272,277,283,291,292,3
     *09,343,360,467,469,475,495,499,501,505,507,527/
      DATA Q/4*0,2*12,9*0,12,0,12,9*0,2*12,11*0,3*12,0,3*12,4*0,3*12,6*0
     */
      DATA LF/1,1,-2,1,-3,1,-4,1,2,1,3,1,4,1,2,-3,-4,1,3,-2,-4,1,4,-2,-3
     *,1,4,2,3,1,4,-15,-14,1,4,15,14,1,4,15,14,-2,-3,-13,-16,1,4,2,3,-13
     *,-16,-14,-15,1,4,13,16,-2,-3,-14,-15,1,4,2,3,13,16,14,15,1,3,5,1,3
     *,5,-9,-11,-7,1,3,5,-10,-8,-12,1,3,5,9,11,7,1,3,5,10,8,12,1,3,5,-4,
     *-2,-6,1,4,3,5,2,6,1,4,3,5,2,6,-9,-11,-7,-10,-8,-12,1,3,5,10,8,12,-
     *9,-11,-7,-4,-2,-6,1,3,5,9,11,7,-10,-8,-12,-4,-2,-6,1,4,3,5,2,6,9,1
     *1,7,10,8,12,1,4,2,3,5,9,7,12,8,10,6,11,1,4,2,3,5,9,7,12,8,10,6,11,
     *-13,-16,-14,-15,-17,-21,-19,-24,-20,-22,-18,-23,1,4,2,3,5,9,7,12,8
     *,10,6,11,13,16,14,15,17,21,19,24,20,22,18,23/LGN/1,0,0,2,0,0,2,0,0
     *,2,0,0,2,0,0,2,0,0,2,0,0,3,4,0,3,4,0,3,4,0,3,4,0,3,0,0,3,0,0,5,7,0
     *,5,3,0,5,3,0,3,5,0,2,0,0,2,4,0,2,4,0,2,6,0,2,5,0,5,0,0,5,0,0,7,10,
     *0,7,4,0,4,7,0,10,7,0,2,5,0,5,14,0,5,14,0,2,0,0,4,2,0,4,2,0,4,2,0,
     *7,8,6,5,0,0,3,6,0,10,11,13,8,10,0,8,10,0,14,19,22,5,8,0,26,5,37,14
     *,5,0/
      DATA GES/1,3*0,1,3*0,1,1,3*0,-1,3*0,2*-1,3*0,1,3*0,2*-1,3*0,
     *-1,3*0,1,0,1,3*0,1,1,3*0,1,3*0,2*-1,3*0,-1,3*0,1,-1,3*0,-1,3*0,-1,
     *1,4*0,1,1,3*0,1,3*0,1,-1,3*0,-1,3*0,-1,1,3*0,-1,3*0,2*-1,3*0,
     *1,2*0,-1,0,-1,4*0,-1,0,-1,0,1,4*0,1,0,1,0,-1,4*0,1,0,1,0,1,4*0,
     *2*-1,4*0,-1,0,-1,0,-1,4*0,1,0,1,0,1,4*0,-1,0,1,0,1,4*0,1,0,-1,
     *3*0,-1,0,-1,0,-1,4*0,-1,0,1,0,1,4*0,1,0,-1,0,1,4*0,1,0,1,0,-1,0,0,
     *1,3*0,1,3*0,1,1,1,0,-1,4*0,1,0,1,0,2*-1,3*0,1,-1,3*0,-1,3*0,1,2*-1
     *,0,1,4*0,1,0,-1,0,1,1,3*0,1,0,1,0,1,4*0,-1,1,1,0,0,-1,3*0,-1,1,0,
     *0,2*-1,3*0,-1,0,-1,0,-1,4*0,3*-1,0,0,1,3*0,2*-1,0,0,1,1,3*0,-1/
      DATA IS/1,5,6,7,11,18,13,17,21,22,28,24,31,29/
      DATA HBR/'P','A','B','C','F','I','R'/
      DATA HS/'M','A','B','C','N','D','-','1','2','3','4','5','6','/'/
      data  GET/3*0,12,3*0,12,3*0,12,
     *0,3*12,0,3*12,0,3*12,0,3*6,0,3*6,0,3*6,18,2*6,0,0,4,0,0,6,0,0,8,
     *0,12,6,0,0,16,0,0,18,0,0,20,12,0,6,2*12,18,12,12,6,6,18,18,6,6,18/
      DATA (NT1(i),i=1,249)
     */656,96,12351,8266,20521,286,8456,20711,381,12636,20806,476,
     *  8646,12731,0,572,0,4657,0,12827,0,20997,0,573,0
     *,4658,0,20998,0,574,0,12829,0,20999,0,575,0,4660,
     * 0,12830,586,4671,8756,21011,596,4681,21021,603,8773,21028,619,
     * 4704,8789,666,12921,8836,21091,761,0,576,0,4661,0,12831,
     * 0,21001,0,577,634,4719,8804,21059,644,682,4767,8852,12937,
     *21107,17022,699,8869,21124,12954,787,4872,685,8855,12940,21110,701
     *,8871,12956,21126,789,795,812,797,778,4863,693,4778,695,716,718,78
     *1,810,17065,117,4202,8287,12372,20542,16457,402,12657,20827,4487,1
     *34,8304,126,12381,4211,20551,411,20836,12666,4496,317,419,507,435,
     *308,8478,323,8493,339,513,529,150,498,18206,160,4245,8330,12415,20
     *585,16500,161,4246,20586,8331,172,12427,350,4435,8520,20775,351,20
     *776,4436,8521,362,456,363,551,455,12710,448,12703,543,449,544,550,
     *173,18215,736,4821,8906,12991,21161,17076,744,12999,831,4916,737,8
     *907,832,839,745,840,21265,1986,22411,2081,22506,2176,2271,2366,226
     *01,2012,22437,2014,2205,2206,2038,22440,2039,2226,2227,22573,22574
     *,1922,22347,1945,1923,1946,22386,1965,22390,1968,22393,1967,1969,2
     *066,22491,2067,2161,2162,2256,2257,2351,2352,22586,3031,27541,3221
     *,3316,2947,27536,2949,27537,2961,2985,2951,27538,3141,3236,3009/
       data (NT1(i),i=250,500)/ 3199,
     *   3294,3411,3506,3601,3981,3696,3886,3791,3437,3463,3725,3746,339
     *0,3393,3347,3370,3491,3586,3966,3681,3871,3776,749,17089,21174,844
     *,21269,1924,18264,22349,1956,18287,22387,2068,22493,18408,2163,225
     *8,2353,22588,18503,3126,856,9026,13111,21281,1236,9406,21661,1426,
     *13681,21851,1616,9786,13871,951,1331,1521,1711,0,578,0,4663,0,
     * 12833,0,21003,0,579,0,4664,0,21004,0,580,0,
     * 12835,0,21005,0,581,0,4666,0,12836,0,582,0,
     *583,0,584,0,585,657,4742,8827,21082,658,4743,21083,659,8829,
     *21084,660,4745,8830,661,662,663,664,112,4197,8282,12367,20537,1645
     *2,129,20547,8299,115,20538,12370,125,12379,146,123,20556,12377,828
     *3,4208,131,8300,148,122,20554,4207,113,20540,4198,124,130,145,116,
     *132,147,319,20832,4387,12384,8489,302,20822,8472,338,313,4398,321,
     *8491,305,315,336,400,20728,8285,4482,12655,397,20727,12652,433,416
     *,12671,408,4493,414,431,410,415,401,409,12664,407,4397,432,398,417
     *,430,528,505,526,509,12669,495,8475,503,492,511,335,320,8490,303,4
     *483,322,312,337,314,20739,306,512,527,496,525,504,510,502,493,1820
     *5,2936,27446,2461,22886,2556,2746,2841,23076,2392,22817,2418,22820
     *,2679,2704,2394,2419,2677,2703,2511,2490,2797,2776,2512,2491,2796,
     *2775,23048,23049,2852,27441,2854,27442,2866/
      DATA (NT1(i),i=501,1000) /                  2890,4007,4033,4105,41
     *26,4076,4171,119,120,20544,20545,16459,16460,531,532,151,152,16482
     *,16483,499,500,18169,18170,18192,18193,20677,20678,179,180,20604,2
     *0605,16519,16520,559,560,274,275,20699,20700,18229,18230,5*0,3*2,3
     **3,3*4,8*0,6*1,6*3,6*5,4*0,3*1,3*2,3*6,4*0,1,8*0,2*2,4*0,3,6*0,4*6
     *2,2*30,4*93,4*124,153,66,214,127,1,1,2*31,155,186,217,5,180,341,6*
     *0,4*93,2*60,4*31,4*155,36,123,157,215,2,2,2*62,186,124,217,180,4,3
     *41,6*0,4*31,2*90,4*62,4*186,122,35,216,187,3,3,2*93,124,155,217,4,
     *150,341,6*0,2*90,2*1,2*62,186,5,120,2*126,4*0,14,3,18,16,0,0,186,3
     *,7,2*93,217,90,216,480,606,0,0,93,186,217,496,0,0,2*93,186,217,0,0
     *,6,423,111,90,7,543,112,16,0,0,15,17,0,0,2*90,0,90,0,0,15,17,0,15,
     *17,0,0,13,19,15,17,3,0,93,3,90,0,3,0,90,0,19,13,17,15,3,3*0,2*5,3*
     *0,2*210,360,3*0,360,210,3*690,5*0,3*62,3*93,3*124,31,186,155,217,8
     **0,6*31,6*93,6*155,2*62,2*186,2*124,2*217,4*0,3*31,3*62,3*186,93,1
     *55,124,217,6*0,3*1860,3*2790,2*4650,5580,5*930,2*3720,6510,3*901,3
     **31,4591,1981,5461,2851,3811,6421,5*1802,3*62,6452,2*1082,2*3692,2
     *822,4712,5432,5*93,3*2703,5613,2*1923,2*4533,3663,6483,1053,3785,1
     *55,2*995,2*4505,5525,2735,2015,6365,5554,1114,6334,2*3604,2*124,46
     *84,2764,1894,5406,2*1836,2*186,3756,966,6396,2*4626,2916,1957/
      DATA (NT1(i),i=1001,1623)  /5497,
     * 217,6307,1027,3637,4567,2887,9278,4*0,3,181,184,162,2*0,2*2790,54
     *66,6426,5580,6510,36,2856,2700,90,6366,5526,6480,210,2736,156,2160
     *2,9992,0,0,2*90,0,90,0,2790,93,2703,0,93,6*0,2*6306,4*6300,2*6,2*1
     *0,2*6310,2*9902,6*0,2*6,4*5,2*10,1,13*2,26*3,13*4,5*5,10*6,5*7,34*
     *5,34*6,34*7,5*8,17,11*8,10,18,18*9,7*10,18,10,18,12*10,8*15,2*13,1
     *1,14,2*11,4*16,10*13,2*16,8*11,12,17,4*12,17,2*12,17,3*12,8,4*12,1
     *77*8,11,14,26*10,11,14,11,14,8*11,4*12,2*8,4*12,2*8,2*12,4*8,6*12,
     *2*8,6*12,2*8/
      data         MM/1,2,3,4,5,8,9,129,444,6654,669,10029,894,13404,111
     *9,16779,1344,20154,6,172,11,131,146,161,446,6671,10031,1346,20171,
     *157,10,127,130,145,202,13,133,148,163,178,193,448,6688,8,1,2,3,4,5
     *,6,9,129,10,157,0,444,669,1119,1344,6654,10029,16779,20154,23*-1,8
     *,1,2,3,4,5,6,9,129,0,444,669,894,1344,6654,10029,13404,20154,25*-1
     */M4/1,2,3,0,4,5,0,6,7,3*0,8,9,10,11,12,13,14,15,16,17,18,19,20,21,
     *0,22,23,24,25,9*0,26,27,28,0,29,30,0,31,32,11*0,33,34,35,0,36,37,0
     *,38,39,11*0,40,41,0,42,43,44,0,45,46,47,48,9*0,49,50,51,0,52,53,0,
     *54,55,56,57,10*0,58,0,0,59,0,60,61,0,62,63,9*0,64,65,66,67,68,69,7
     *0,71,72,73,10*0,74,75,76,0,77,78,0,79,80,12*0,81,0,0,82,0,0,83,0,8
     *4,85,86,8*0,87,19*0,88,19*0,89,19*0,90,19*0,91,19*0,92,19*0,93,19*
     *0,94,19*0/
      data SY/1,6*2,4*3,6*4,11*5,3*6,1,3*2,3,5,4,4,4*5,6,6/IRC/72/
      data (tgrp(i),i=1,466)/1,6,3*8,7,9,9,7,9,9,7,9,9,6,6,6*8,2*7,4*9,
     1 2*7,4*9,2*7,4*9,6,3*8,7,9,9,7,9,9,7,9,9,3,3*5,4,3,3,6*5,4,4,3,3*5
     2,4,25,35,2*38,44,42,28,40,46,39,26,36,28,39,40,46,32,2*41,45,2*29,
     3 2*33,26,36,27,37,2*30,34,2*31,43,25,38,35,38,44,42,28,40,46,39,
     4 26,36,28,39,40,46,32,45,2*41,2*29,2*33,26,36,27,37,2*30,34,2*31,
     5 43,25,2*38,35,44,42,28,40,46,39,26,36,28,39,40,46,32,45,2*41,2*29
     6,2*33,26,36,27,37,2*30,34,2*31,43,16,3*21,23,22,17,20,17,20,17,20,
     7 3*18,19,24,81,82,75,79,76,77,76,80,99,107,100,101,102,103,
     8 108,104,105,106,109,110,111,121,112,113,114,122,115,119,116,
     9 120,117,118,89,97,90,91,92,93,94,91,92,98,143,146,144,144,
     * 156,160,158,161,157,159,150,155,152,152,149,151,151,174,168,169,
     1 169,171,171,173,183,184,185,186,187,188,189,190,177,178,178,180,
     2 180,182,195,196,197,198,199,215,216,217,218,219,220,207,211,209,
     3213,208,213,214,210,2,10,3*12,13,2*15,13,2*15,13,2*15,11,3*14,2*10
     4,6*12,2*13,4*15,2*13,4*15,2*13,4*15,2*11,6*14,10,3*12,13,2*15,13,
     5 2*15,13,2*15,11,3*14,47,3*65,71,69,51,74,63,51,74,63,53,64,53,49,
     6 72,2*67,66,55,64,58,51,74,63,51,74,63,2*57,2*59,2*62,49,72,2*67,
     7 66,51,74,63,52,54,68,54,68,57,60,50,49,72,2*67,66,51,74,63,52,54,
     8 68,54,68,57,60,50,61,53,54,68,55,64,56,57,60,62,48,2*52,53,64,53,
     9 64,56,59,50,53,54,68,55,64,56,57,60,61,73,62,2*52,2*58,2*60,2*62/
      data (tgrp(i),i=467,541) /70,147,148,83,87,84,85,86,88,123,139,124
     1,140,125,126,127,128,129,130,131,132,133,134,135,136,137,138,141,
     2 142,164,166,165,167,162,163,191,192,193,194,175,176,2*221,2*229,
     3 2*225,2*222,2*223,2*226,2*224,2*227,2*228,2*230,2*200,2*204,
     4 2*202,2*201,2*205,2*206,2*203/
      data trafo /0,4,4,2,7,2,2,27,4,4,7,6,22,24,0,0,5,5,0,0,9,9,5,5,5,
     1 5,9,9,4*0,2*29,8,8,25,25,2*20,1,1,3,11,1,1,31,3,3,11,10,21,
     2 23,4,4,2,7,4,0,0,5,5,0,0,9,9,0,0,1,1,3,11,1,3*1,5,5*1,5,1,1,5,1,
     3 5,5,1,1,5,1,5,1,5,1,5,5,1,5,1,5,1,5,1,1,2,3,7*2,3,3,3,3,2,3,3,3*2
     4,3,3,2,3,6*2,3,2,3,2,2,0,0,4,6*0,4,0,0,4,0,4,4,3*0,4,4,0,4,0,4,4,
     5 3*0,4,0,4,3*0,1,2,5*0,1,1,2,2,0,2,1,8*0,-1,32*0,2*-1,4*0,-1,9*0,
     6 -1,2*0,-1,3*0,-1,0,-1,11*0,-1,0,-1,17*0,-1,3*0,4,2,4,7,2,2,47,4,4
     7,7,6,42,44,4,2,4,6,0,0,5,5,0,0,2*9,4*5,9,9,4*0,2*49,8,8,2*45,2*40
     8 ,0,0,5,5,0,0,8,8,1,1,3,11,1,1,51,3,3,11,10,41,43,1,1,3,10,
     8 0,1,2,3*0,4,0,3,2,3,3*0,3,1,1,0,3,1,1,3,1,0,4,1,3,2,5,1,5,0,2,4,
     9 3*2,1,4,2,1,5,2,3*1,2,2,0,2,3*0,2,5,0,5,1,4,5,4,4,5,5,3,4,2,
     * 3,5,0,0,2,1,0,4,3,5,0,0,3,4,4,2,2,4*1,3,3,0,5,2,2,3*0,1,4,2,0,2,
     1 1,5,0,3,0,74*0/
      data list/1,292,59,67,63,15,29,19,31,310,336,314,324,340,326,
     1 176,182,188,191,183,179,181,180,192,142,152,168,148,163,170,174,
     2 158,165,172,145,153,169,143,155,149,160,147,175,146,159,150,361,
     3 438,412,411,384,439,373,430,451,434,409,461,392,455,456,465,372,
     4 374,364,416,378,431,366,467,365,413,457,368,
     5 195,197,198,199,196,200,193,194,470,472,473,474,471,475,225,227,
     6 228,229,230,231,232,233,226,234,201,203,204,205,206,208,209,210,
     7 202,207,211,212,213,215,216,217,219,221,223,224,220,222,214,218,
     8 476,478,480,481,482,483,484,485,486,487,488,489,490,491,492,493,
     9 477,479,494,495,235,237,238,236,468,469,249,245,250,247,251,248,
     * 246,239,243,241,244,240,242,500,501,496,498,497,499,253,254,255,
     1 256,257,258,252,506,507,267,268,269,270,271,272,259,260,261,262,
     2 263,264,265,266,502,503,504,505,273,274,275,276,277,529,535,533,
     3 541,531,537,539,284,288,286,291,285,289,287,290,278,279,280,281,
     4 282,283,509,515,517,521,513,519,523,525,511,527/
c-----Centrings :
      data cent/4*1,3,1,1,3,3,1,1,3,1,1,3,4*1,3,3,4,5,5,10*1,3*3,4*2,
     1 4,4,3*5,16*1,6*3,4,4,4*5,4*1,5,5,1,5,4*1,5,5,8*1,5,5,8*1,4*5,
     2 8*1,4*5,16*1,4*5,3*1,6,1,6,6*1,6,4*1,6,6,4*1,6,6,28*1,4,5,1,5,
     3 1,1,4,4,5,1,5,1,1,4,4,5,1,1,5,1,4,5,1,4,5,4*1,4*4,5,5/
      data (spg(i),i=1,119)
     1/'P 1','P -1','P 2','P 21','C 2','P m','P c','C m','C c','P 2/m',
     2 'P 21/m','C 2/m','P 2/c','P 21/c','C 2/c','P 2 2 2','P 2 2 21',
     3 'P 21 21 2','P 21 21 21','C 2 2 21','C 2 2 2','F 2 2 2','I 2 2 2'
     4,'I 21 21 21','P m m 2','P m c 21','P c c 2','P m a 2','P c a 21',
     5 'P n c 2','P m n 21','P b a 2','P n a 21','P n n 2','C m m 2',
     6 'C m c 21','C c c 2','A m m 2','A b m 2','A m a 2','A b a 2',
     7 'F m m 2','F d d 2','I m m 2','I b a 2','I m a 2','P m m m',
     8 'P n n n','P c c m','P b a n','P m m a','P n n a','P m n a',
     9 'P c c a','P b a m','P c c n','P b c m','P n n m','P m m n',
     * 'P b c n','P b c a','P n m a','C m c m','C m c a','C m m m',
     1 'C c c m','C m m a','C c c a','F m m m','F d d d','I m m m',
     2 'I b a m','I b c a','I m m a',
     3 'P 4','P 41','P 42',' ','I 4','I 41','P -4','I -4',
     4 'P 4/m','P 42/m','P 4/n','P 42/n','I 4/m','I 41/a',
     5'P 4 2 2','P 4 21 2','P 41 2 2','P 41 21 2','P 42 2 2','P 42 21 2'
     6,2*' ','I 4 2 2','I 41 2 2','P 4 m m','P 4 b m','P 42 c m','P 42 n
     7 m','P 4 c c','P 4 n c','P 42 m c','P 42 b c','I 4 m m','I 4 c m',
     8'I 41 m d','I 41 c d','P -4 2 m','P -4 2 c','P -4 21 m','P -4 21 c
     9','P -4 m 2','P -4 c 2','P -4 b 2','P -4 n 2','I -4 m 2'/
      data (spg(i),i=120,230) / 'I -4 c 2','I -4 2 m','I -4 2 d',
     1 'P 4/m m m','P 4/m c c','P 4/n b m','P 4/n n c','P 4/m b m',
     2 'P 4/m n c','P 4/n m m','P 4/n c c','P 42/m m c','P 42/m c m',
     3 'P 42/n b c','P 42/n n m','P 42/m b c','P 42/m n m','P 42/n m c',
     4 'P 42/n c m','I 4/m m m','I 4/m c m','I 41/a m d','I 41/a c d',
     5 'P 3','P 31',' ','R 3','P -3','R -3','P 3 1 2','P 3 2 1',
     6 'P 31 1 2','P 31 2 1',' ',' ','R 3 2','P 3 m 1','P 3 1 m',
     7 'P 3 c 1','P 3 1 c','R 3 m','R 3 c','P -3 1 m','P -3 1 c',
     8 'P -3 m 1','P -3 c 1','R -3 m','R -3 c','P 6','P 61',' ','P 62',
     9 ' ','P 63','P -6','P 6/m','P 63/m','P 6 2 2','P 61 2 2',' ',
     * 'P 62 2 2',' ','P 63 2 2','P 6 m m','P 6 c c','P 63 c m',
     1'P 63 m c','P -6 m 2','P -6 c 2','P -6 2 m','P -6 2 c','P 6/m m m'
     2,'P 6/m c c','P 63/m c m','P 63/m m c','P 2 3','F 2 3','I 2 3',
     3'P 21 3','I 21 3','P m -3','P n -3','F m -3','F d -3','I m -3',
     4 'P a -3','I a -3','P 4 3 2','P 42 3 2','F 4 3 2','F 41 3 2',
     5 'I 4 3 2',' ','P 41 3 2','I 41 3 2','P -4 3 m','F -4 3 m',
     6'I -4 3 m','P -4 3 n','F -4 3 c','I -4 3 d','P m -3 m','P n -3 n',
     7'P m -3 n','P n -3 m','F m -3 m','F m -3 c','F d -3 m','F d -3 c',
     8 'I m -3 m','I a -3 d'/
c     transformations :
      data  abc/0.,1.,0.,0.,0.,1.,1.,0.,0.,  0.,0.,1.,1.,0.,0.,0.,1.,0.,
     1      1.,0.,0.,0.,0.,-1.,0.,1.,0.,  0.,1.,0.,-1.,0.,0.,0.,0.,1.,
     2      0.,0.,1.,0.,-1.,0.,1.,0.,0.,  0.,-1.,0.,1.,0.,0.,0.,1.,1.,
     3      0.,-1.,-1.,1.,0.,0.,0.,0.,1.,  0.,0.,-1.,0.,1.,0.,1.,0.,1.,
     4      -1.,0.,-1.,0.,1.,0.,1.,0.,0.,  -1.,0.,0.,0.,0.,1.,1.,1.,0.,
     5   -1.,-1.,0.,0.,0.,1.,0.,1.,0.,  0.,0.,-1.,-1.,0.,0.,0.,1.,1.,
     6   0.,-1.,-1.,-1.,0.,0.,0.,1.,0.,  -1.,0.,0.,0.,-1.,0.,1.,0.,1.,
     7   -1.,0.,-1.,0.,-1.,0.,0.,0.,1.,  0.,-1.,0.,0.,0.,-1.,1.,1.,0.,
     8   -1.,-1.,0.,0.,0.,-1.,1.,0.,0.,  0.,1.,0.,-1.,0.,0.,0.,-1.,1.,
     9   0.,1.,-1.,-1.,0.,0.,0.,0.,1.,  0.,0.,1.,0.,-1.,0.,1.,0.,-1.,
     *   -1.,0.,1.,0.,-1.,0.,1.,0.,0.,  1.,0.,0.,0.,0.,-1.,-1.,1.,0.,
     1   1.,-1.,0.,0.,0.,-1.,0.,1.,0.,  0.,0.,1.,1.,0.,0.,0.,1.,-1.,
     2   0.,-1.,1.,1.,0.,0.,0.,1.,0.,  1.,0.,0.,0.,1.,0.,-1.,0.,1.,
     3   1.,0.,-1.,0.,1.,0.,0.,0.,1.,  0.,1.,0.,0.,0.,1.,1.,-1.,0.,
     4   -1.,1.,0.,0.,0.,1.,1.,0.,0.,  -1.,0.,0.,0.,-1.,0.,0.,0.,-1./
 
c     initialisations :
      NBR = 0
      z = 0
      iz = 0
      ngc = 0
      ngo = 0
      id = 0
      LT = 0
      do 15 i=1,3
      plus(i) = 0.
      do 16 j=1,48
   16 t(j,i) = 0
   15 s(i) = 0
      DO 17 i=1,3
      DO 17 j=1,3
      DO 17 k=1,48
   17 r(k,j,i) = 0
      do 26 i=1,48
   26 LGT(I) = 0
 
C     CHECK THE SYMBOL,DETERMINE BRAVAIS LATTICE
      ier = 0
   95 DO 99 I=1,7
      IN(I)=0
   99 IF(NT(1).EQ.HBR(I)) NBR=I
      IF(NBR.EQ.0.OR.NT(2).NE.' ') return 1
      n = 0
      DO 100 I=2,16
      IF(NT(I).NE.' ') GOTO 101
      K=0
      N=N+1
      GOTO 100
  101 M=0
      DO 102 J=1,14
  102 IF(NT(I).EQ.HS(J)) M=J
      IF(M.EQ.0.OR.K.GT.3) return 1
      IN(N+1)=IN(N+1)+M*15**K
      K=K+1
  100 CONTINUE
      DO 109 I=1,3
      NET(I)=0
      DO 108 J=1,43
  108 IF(MM(J,I).EQ.IN(I+1)) NET(I)=J
  109 IF(NET(I).EQ.0) return 1
      MD4=M4(NET(2),NET(3))
      IF(MD4.EQ.0) return 1
      MC=MD4+NET(1)*95+(NBR-1)*4085
      DO 113 I=1,541
  113 IF(MC.EQ.NT1(I)) Z=I
c     symbol may not be accepted if it is short monoclinic symbol
c     or if the space group is Icab (nr.73)
      IF(NT(1).EQ.'I'.AND.NT(3).EQ.'C'.AND.NT(5).EQ.'A'.AND.NT(7).EQ.
     1   'B') THEN
        NGR = 73
        IFPLUS = 1
        NTRANS = -2
        PLUS(1) = .25
        PLUS(2) = .25
        PLUS(3) = .25
        NSHTRA = 5
        GO TO 250
      ENDIF
 
      IF(Z.EQ.0) call SYMBOL(nbr,*601,*95)
c     transform to standard space group setting
      ntrans = trafo(z)
      if(ntrans.gt.0) then
*     transform -> lower case letters :
        nbl = 0
        aux = ' '
        aux(1:1) = NT(1)
        k = 2
        do 700 i=3,16
        k = k + 1
        aux(k:k) = NT(i)
        if(NT(i).eq.' ') then
          nbl = nbl + 1
          if (nbl.eq.2) go to 710
          go to 700
        else
          nbl = 0
        endif
        do 701 j=1,6
        if(NT(i).eq.UP(j))then
          aux(k:k) = low(j)
          go to 700
        endif
  701   continue
  700   continue
  710   do 703 i=16,1,-1
        if(aux(i:i).ne.' ') then
          k = i+1
          aux(k:k) = '.'
          go to 704
        endif
  703   continue
  704   write(13,888) aux
  888 format('REMARK Transformed from setting  ',a17)
      endif
      ngr = tgrp(z)
      iz = z
 
*     Give warnings for groups 17 & 20:
  250 if(long.eq.0) go to 251
      if(z.eq.182.or.z.eq.183) then
        if(isc.eq.1)write(*,801)
        write(nout,801)
      else if(z.eq.184.or.z.eq.185) then
        if(isc.eq.1)write(*,802)
        write(nout,802)
      else if(z.eq.186.or.z.eq.187) then
        if(isc.eq.1)write(*,803)
        write(nout,803)
      endif
  801 format(' WARNING : The origin should be at  2 1 21;'/
     1' if the origin is at  1 2 21, substract 1/4 from z-coordinates.')
  802 format(' WARNING : The origin should be at  21 2 1;'/
     1' if the origin is at  21 1 2, substract 1/4 from x-coordinates.')
  803 format(' WARNING : The origin should be at  1 21 1;'/
     1' if the origin is at  2 21 1, substract 1/4 from y-coordinates.')
 
  251 z = list(ngr)
      spgr = spg(ngr)
      nbr = cent(ngr)
      nb = nbr
      if(nbr.gt.2) nb = nbr + 1
      if(long.gt.0) write(nout,301) ngr
      if(isc.eq.1.and.long.gt.0) write(*,301) ngr
  301 format(' Number in IT : ',i3)
      DO 115 I=1,45
  115 IF(NT2(I).LT.Z) NGC=I
      SYS=SY(NGC)
      NSE=NT1(Z+1082)
      NET(3)=NT1(Z+541)/900+1
      NET(2)=(NT1(Z+541)-900*(NET(3)-1))/30+1
      NET(1)=1+MOD(NT1(Z+541),30)
      NCS=1-NGC/32
      ND=NGC
      IF(ND.GT.31) ND=IS(NGC-31)
C     ROTATION PARTS
      DO 110 I=1,216
      IF(LF(I).EQ.1) ID=ID+1
      IF(ID-ND) 110,112,120
  112 M=LF(I)*ISIGN(1,LF(I))+24*(5/SYS)*(SYS/5)
      NGO=NGO+1
      DO 111 K=1,3
      DO 111 L=1,3
  111 R(NGO,K,L)=GES(K,L,M)*ISIGN(1,LF(I))
  110 CONTINUE
C     MULTIPLCATION TABLE
  120 DO 90 I=1,NGO
      DO 124 J=1,3
      DO 124 K=1,3
  124 IF(NCS.EQ.0) R(NGO+I,J,K)=-R(I,J,K)
      DO 90 J=1,NGO
      DO 92 K=1,3
      DO 92 L=1,3
   92 SC(K,L)=R(I,K,1)*R(J,1,L)+R(I,K,2)*R(J,2,L)+R(I,K,3)*R(J,3,L)
      DO 93 K=1,NGO
      DO 89 L=1,3
      DO 89 M=1,3
   89 IF(SC(L,M).NE.R(K,L,M)) GOTO 93
      NGT(I,J)=K
      NGT(NGO+I,J)=(K+NGO)*(1-NCS)
      NGT(I,NGO+J)=(K+NGO)*(1-NCS)
      NGT(NGO+I,NGO+J)=K*(1-NCS)
      GOTO 90
   93 CONTINUE
   90 CONTINUE
      NGO=NGO+NGO*(1-NCS)
C     FIX SEMINVARIANT CONDITIONS, TRANSLATION PARTS FOR GENERATORS
      DO 129 I=1,3
      ID=LGN(I,NGC)
      DO 129 J=1,3
      IF(ID.NE.0) T(ID,J)=GET(J,NET(I))
  129 SC(I,J)=SEM(I,J,NSE)
C     COMPLETE TRANSLATION PARTS
  128 DO 131 I=1,3
      IF(LGN(I,NGC).EQ.0) GOTO 131
      LT=LT+1
      LGT(LT)=LGN(I,NGC)
  131 CONTINUE
  135 IF(LT.EQ.NGO) GOTO 200
      N=0
      DO 132 I=1,LT
      DO 132 J=1,LT
      KL=NGT(LGT(I),LGT(J))
      DO 133 M=1,NGO
      IF(LGT(M).EQ.KL) GOTO 132
  133 continue
      DO 136 K=1,3
      DO 134 L=1,3
  134 T(KL,K)=T(KL,K)+R(LGT(I),K,L)*T(LGT(J),L)
  136 T(KL,K)=MOD(T(KL,K)+T(LGT(I),K)+48,24)
      N=N+1
      LGT(LT+N)=KL
  132 CONTINUE
      LT=LT+N
      GOTO 135
  200 DO 211 I=1,NGO
      DO 216 J=1,3
      T(I,J)=T(I,J)+R(I,J,1)*S(1)+R(I,J,2)*S(2)+R(I,J,3)*S(3)-S(J)
  216 T(I,J)=MOD(T(I,J)+48,24)
      IF(NB.EQ.1.OR.NB.EQ.7) GOTO 211
      DO 214 L=1,4
      DO 212 K=1,3
  212 NET(K)=MOD(T(I,K)+Q(K,L,NB-1),24)
      IF(IRC.LE.NET(1)+NET(2)+NET(3)) GOTO 214
      IRC=NET(1)+NET(2)+NET(3)
      DO 213 K=1,3
  213 T(I,K)=NET(K)
  214 CONTINUE
  211 IRC=72
c     transformation matrix :
      ifmat = 0
      n = mod(ntrans,20)
      IF(NTRANS.EQ.-2) N = 30
      if(ntrans.eq.-1) ifmat = 1
      if(n.gt.0) then
         ifmat = 2
         IF(NTRANS.GT.0)call TRA(n,*601)
         do 600 k=1,9
         ss(k) = abc(k,n)
  600   continue
      endif
      IF(NTRANS.EQ.-2) RETURN
c-----some transformations require a different originshift from that
c     indicated in data in trafo :
      if(n.eq.13.or.n.eq.25)then
         if(iz.eq.8)  ntrans = 7
         if(iz.eq.11) ntrans = 27
         if(iz.eq.299)ntrans = 7
         if(iz.eq.302)ntrans = 47
      else if(n.eq.15.or.n.eq.27)then
         if(iz.eq.28) ntrans = 29
         if(iz.eq.34) ntrans = 9
         if(iz.eq.323)ntrans = 49
         if(iz.eq.329)ntrans = 9
      else if(n.eq.17.or.n.eq.29)then
         if(iz.eq.47) ntrans = 11
         if(iz.eq.50) ntrans = 31
         if(iz.eq.350)ntrans = 11
         if(iz.eq.353)ntrans = 51
      endif
      if(ntrans.lt.20) return
       ifplus = 1
       plus(2) = .25
      if(ntrans.ge.40) then
         plus(1) = .25
         nshtra = 6
      else
         nshtra = 17
      endif
      return
c     space groupsymbol not accepted :
  601 return 1
      END
*COPY SYMBOL
      subroutine SYMBOL(nbr,*,*)
c     changes short spacegroupsymbol which is not accepted by subroutine
c     BURZ into the corresponding long symbol (only for monoclinic)
 
      common long,nout,idm,inf,isc,ipol,r,ngr,iocfl,vol,nfl,volrat
      common /bur/nt,spgr
      common /cel/ a,b,c,al,be,ga,alf,bet,gam,cosa,cosb,cosg
      character*1 nt(16),nt1(16),spgr*10
      character*14 ntt,p(17),ba(7),bb(7),bc(7),bi(9)
 
      data p/'2','21','M','N','A','B','C','2/M','21/M','2/A','2/B',
     1'2/C','2/N','21/A','21/B','21/C','21/N'/
      data ba/'2','M','N','A','2/M','2/A','2/N'/
      data bb/'2','M','N','B','2/M','2/B','2/N'/
      data bc/'2','M','N','C','2/M','2/C','2/N'/
      data bi/'2','M','A','B','C','2/M','2/A','2/B','2/C'/
 
c     check if monoclinic short symbol :
      ntt = ' '
      do 15 i=1,14
   15 write(ntt(i:i),'(a1)') nt(i+2)
 
      go to (21,22,23,24,25,26,25),nbr
c     F or R lattice are not monoclinic :
   25 return 1
   21 do 31 i=1,17
      if(ntt.eq.p(i)) go to 50
   31 continue
      return 1
   22 do 32 i=1,7
      if(ntt.eq.ba(i)) go to 50
   32 continue
      return 1
   23 do 33 i=1,7
      if(ntt.eq.bb(i)) go to 50
   33 continue
      return 1
   24 do 34 i=1,7
      if(ntt.eq.bc(i)) go to 50
   34 continue
      return 1
   26 do 36 i=1,9
      if(ntt.eq.bi(i)) go to 50
   36 continue
      return 1
 
   50 do 4 i=1,16
    4 nt1(i) = ' '
c     information in nt starts in 1st column (see MAIN, lines 100-110)
 
      ii = 1
      if(al.ne.0..and.al.ne.90.) ii = 2
      if(be.ne.0..and.be.ne.90.) ii = ii + 2
      if(ga.ne.0..and.ga.ne.90.) ii = ii + 4
c     for monoclinic normally ii = 2,3,5
c     if ii=1, all angles = 90; in this case we shall suppose that
c     b-axis setting, cellchoice 1 was meant.
      go to (10,2,3,1,5,1,1,1),ii
c-----impossible combination :
    1 return 1
c-----a-axis unique :
    2 do 6 i=3,16
      if(nt(i).ne.' ') go to 6
      nt(i+1) = '1'
      nt(i+2) = ' '
      nt(i+3) = '1'
      go to 40
    6 continue
   10 if(long.gt.0) write(nout,41)
      if(isc.eq.1.and.long.gt.0) write(*,41)
   41 format(' Input of monoclinic space group with all angles = 90 ',
     1' may lead to difficulties.'/' The program assumes b-axis',
     2' unique. If different setting,'/
     3' rerun program with monoclinic angle=90.0001')
c-----b-axis unique :
    3 nt1(3) = '1'
      do 7 i=3,16
      if(nt(i).eq.' ') go to 8
      nt1(i+2) = nt(i)
    7 continue
    8 nt1(i+3) = '1'
      do 9 i=3,16
    9 nt(i) = nt1(i)
      go to 40
c-----c-axis unique:
    5 nt1(3) = '1'
      nt1(5) = '1'
      do 11 i=3,12
   11 nt1(i+4) = nt(i)
      do 12 i=3,16
   12 nt(i) = nt1(i)
   40 if(long.gt.0) write(nout,42) nt
      if(isc.eq.1.and.long.gt.0) write(*,42) nt
   42 format(' Complete symbol for space group setting : ',16a1)
      return 2
      end
*COPY TRA
      subroutine TRA(n,*)
c     transformation of cell parameters to standard space group
c     called by BURZ , subroutine of STIDY
 
      common long,nout,idm,inf,isc,ipol,r,ngr,iocfl,vol,nfl,volrat
      common /bur/nt,spgr
      common /cel/ a,b,c,al,be,ga,alf,bet,gam,cosa,cosb,cosg
      common /matr/ifmat,ifsh,ifplus,xmat(3,3),plus(3),sh(3),nabc,nsh,
     1 nshtra,ifnig,xmsave(3,3),shif(3),minsh
      character axes*9,nt*16,spgr*10
 
      eps = 0.0001
      alf = al/r
      bet = be/r
      gam = ga/r
      cosa = cos(alf)
      cosb = cos(bet)
      cosg = cos(gam)
c
      go to (1,2,3,4,5,6,7,8,9,10,11) ,n
c----- b,c,a
    1 axes = 'b,c,a'
      an = b
      bn = c
      cn = a
      ben = ga
      go to 30
c----- c,a,b
    2 axes = 'c,a,b'
      an = c
      bn = a
      cn = b
      ben = al
      go to 30
c----- a,-c,b
    3 axes = 'a,-c,b'
      an = a
      bn = c
      cn = b
      ben = ga
      go to 30
c----- b,-a,c
    4 axes = 'b,-a,c'
      an = b
      bn = a
      cn = c
      ben = al
      go to 30
c----- c,-b,a
    5 axes = 'c,-b,a'
      an = c
      bn = b
      cn = a
      ben = be
      go to 30
    6 if(al.lt.90.) go to 18
      if(c.lt.b) go to 12
c----- -b,a,b+c
      axes = '-b,a,b+c'
      an = b
      bn = a
      cn2 = b**2+c**2+2.*b*c*cosa
      cn = sqrt(cn2)
      if(b.lt.eps.or.cn.lt.eps) go to 50
      ben = r*acos(-((b**2+cn2-c**2)/(2.*b*cn)))
      go to 30
    7 if(al.lt.90.) go to 19
      if(b.lt.c) go to 13
c----- -b-c,a,c
      axes = '-b-c,a,c'
      an2 = b**2+c**2+2.*b*c*cosa
      an = sqrt(an2)
      bn = a
      cn = c
      if(c.lt.eps.or.an.lt.eps) go to 50
      ben = r*acos(-((an2+c**2-b**2)/(2.*an*c)))
      go to 30
    8 if(be.lt.90.) go to 20
      if(a.lt.c) go to 14
c----- -c,b,a+c
      axes = '-c,b,a+c'
      an = c
      bn = b
      cn2 = a**2+c**2+2.*a*c*cosb
      cn = sqrt(cn2)
      if(c.lt.eps.or.cn.lt.eps) go to 50
      ben = r*acos(-((c**2+cn2-a**2)/(2.*c*cn)))
      go to 30
    9 if(be.lt.90.) go to 21
      if(c.lt.a) go to 15
c----- -(a+c),b,a
      axes = '-a-c,b,a'
      an2 = a**2+c**2+2.*a*c*cosb
      an = sqrt(an2)
      bn = b
      cn = a
      if(a.lt.eps.or.an.lt.eps) go to 50
      ben = r*acos(-((an2+a**2-c**2)/(2.*an*a)))
      go to 30
   10 if(ga.lt.90.) go to 22
      if(b.lt.a) go to 16
c----- -a,c,a+b
      axes = '-a,c,a+b'
      an = a
      bn = c
      cn2 = a**2+b**2+2.*a*b*cosg
      cn = sqrt(cn2)
      if(a.lt.eps.or.cn.lt.eps) go to 50
      ben = r*acos(-((cn2+a**2-b**2)/(2.*cn*a)))
      go to 30
   11 if(ga.lt.90.) go to 23
      if(a.lt.b) go to 17
c----- -(a+b),c,b
      axes = '-a-b,c,b'
      an2 = a**2+b**2+2.*a*b*cosg
      bn = c
      cn = b
      an = sqrt(an2)
      if(b.lt.eps.or.an.lt.eps) go to 50
      ben = r*acos(-((an2+b**2-a**2)/(2.*an*b)))
      go to 30
   12 n = 12
c----- -c,-a,b+c
      axes = '-c,-a,b+c'
      an = c
      bn = a
      cn2 = b**2+c**2+2.*b*c*cosa
      cn = sqrt(cn2)
      if(c.lt.eps.or.cn.lt.eps) go to 50
      ben = r*acos(-((c**2+cn2-b**2)/(2.*c*cn)))
      go to 30
   13 n = 13
c----- -b-c,-a,b
      axes = '-b-c,-a,b'
      an2 = b**2+c**2+2.*b*c*cosa
      an = sqrt(an2)
      bn = a
      cn = b
      if(b.lt.eps.or.an.lt.eps) go to 50
      ben = r*acos(-((an2+b**2-c**2)/(2.*an*b)))
      go to 30
   14 n = 14
c----- -a,-b,a+c
      axes = '-a,-b,a+c'
      an = a
      bn = b
      cn2 = a**2+c**2+2.*a*c*cosb
      cn = sqrt(cn2)
      if(a.lt.eps.or.cn.lt.eps) go to 50
      ben = r*acos(-((a**2+cn2-c**2)/(2.*a*cn)))
      go to 30
   15 n = 15
c----- -(a+c),-b,c
      axes = '-a-c,-b,c'
      an2 = a**2+c**2+2.*a*c*cosb
      an = sqrt(an2)
      bn = b
      cn = c
      if(c.lt.eps.or.an.lt.eps) go to 50
      ben = r*acos(-((an2+c**2-a**2)/(2.*an*c)))
      go to 30
   16 n = 16
c----- -b,-c,a+b
      axes = '-b,-c,a+b'
      an = b
      bn = c
      cn2 = a**2+b**2+2.*a*b*cosg
      cn = sqrt(cn2)
      if(b.lt.eps.or.cn.lt.eps) go to 50
      ben = r*acos(-((cn2+b**2-a**2)/(2.*cn*b)))
      go to 30
   17 n = 17
c----- -(a+b),-c,a
      axes = '-a-b,-c,a'
      an2 = a**2+b**2+2.*a*b*cosg
      bn = c
      cn = a
      an = sqrt(an2)
      if(a.lt.eps.or.an.lt.eps) go to 50
      ben = r*acos(-((an2+a**2-b**2)/(2.*an*a)))
      go to 30
   18 if(c.lt.b) go to 24
      n = 18
c---- b,-a,c-b
      axes = 'b,-a,c-b'
      an = b
      bn = a
      cn2 = b**2+c**2-2.*b*c*cosa
      cn = sqrt(cn2)
      if(b.lt.eps.or.cn.lt.eps) go to 50
      ben = r*acos(-((b**2+cn2-c**2)/(2.*b*cn)))
      go to 30
   19 if(b.lt.c) go to 25
      n = 19
c----- b-c,-a,c
      axes = 'b-c,-a,c'
      an2 = b**2+c**2-2.*b*c*cosa
      an = sqrt(an2)
      bn = a
      cn = c
      if(c.lt.eps.or.an.lt.eps) go to 50
      ben = r*acos(-((an2+c**2-b**2)/(2.*an*c)))
      go to 30
   20 if(a.lt.c) go to 26
      n = 20
c----- c,-b,a-c
      axes = 'c,-b,a-c'
      an = c
      bn = b
      cn2 = a**2+c**2-2.*a*c*cosb
      cn = sqrt(cn2)
      if(c.lt.eps.or.cn.lt.eps) go to 50
      ben = r*acos(-((c**2+cn2-a**2)/(2.*c*cn)))
      go to 30
   21 if(c.lt.a) go to 27
      n = 21
c----- c-a,-b,a
      axes = 'c-a,-b,a'
      an2 = a**2+c**2-2.*a*c*cosb
      an = sqrt(an2)
      bn = b
      cn = a
      if(a.lt.eps.or.an.lt.eps) go to 50
      ben = r*acos(-((an2+a**2-c**2)/(2.*an*a)))
      go to 30
   22 if(b.lt.a) go to 28
      n = 22
c----- a,-c,b-a
      axes = 'a,-c,b-a'
      an = a
      bn = c
      cn2 = a**2+b**2-2.*a*b*cosg
      cn = sqrt(cn2)
      if(a.lt.eps.or.cn.lt.eps) go to 50
      ben = r*acos(-((cn2+a**2-b**2)/(2.*cn*a)))
      go to 30
   23 if(a.lt.b) go to 29
      n = 23
c----- a-b,-c,b
      axes = 'a-b,-c,b'
      an2 = a**2+b**2-2.*a*b*cosg
      bn = c
      cn = b
      an = sqrt(an2)
      if(b.lt.eps.or.an.lt.eps) go to 50
      ben = r*acos(-((an2+b**2-a**2)/(2.*an*b)))
      go to 30
   24 n = 24
c---- c,a,b-c
      axes = 'c,a,b-c'
      an = c
      bn = a
      cn2 = b**2+c**2-2.*b*c*cosa
      cn = sqrt(cn2)
      if(c.lt.eps.or.cn.lt.eps) go to 50
      ben = r*acos(-((c**2+cn2-b**2)/(2.*c*cn)))
      go to 30
c----- c-b,a,b
   25 n = 25
      axes = 'c-b,a,b'
      an2 = b**2+c**2-2.*b*c*cosa
      an = sqrt(an2)
      bn = a
      cn = b
      if(b.lt.eps.or.an.lt.eps) go to 50
      ben = r*acos(-((an2+b**2-c**2)/(2.*an*b)))
      go to 30
c----- a,b,c-a
   26 n = 26
      axes = 'a,b,c-a'
      an = a
      bn = b
      cn2 = a**2+c**2-2.*a*c*cosb
      cn = sqrt(cn2)
      if(a.lt.eps.or.cn.lt.eps) go to 50
      ben = r*acos(-((a**2+cn2-c**2)/(2.*a*cn)))
      go to 30
c----- a-c,b,c
   27 n = 27
      axes = 'a-c,b,c'
      an2 = a**2+c**2-2.*a*c*cosb
      an = sqrt(an2)
      bn = b
      cn = c
      if(c.lt.eps.or.an.lt.eps) go to 50
      ben = r*acos(-((an2+c**2-a**2)/(2.*an*c)))
      go to 30
c----- b,c,a-b
   28 n = 28
      axes = 'b,c,a-b'
      an = b
      bn = c
      cn2 = a**2+b**2-2.*a*b*cosg
      cn = sqrt(cn2)
      if(b.lt.eps.or.cn.lt.eps) go to 50
      ben = r*acos(-((cn2+b**2-a**2)/(2.*cn*b)))
      go to 30
c----- b-a,c,a
   29 n = 29
      axes = 'b-a,c,a'
      an2 = a**2+b**2-2.*a*b*cosg
      bn = c
      cn = a
      an = sqrt(an2)
      if(a.lt.eps.or.an.lt.eps) go to 50
      ben = r*acos(-((an2+a**2-b**2)/(2.*an*a)))
 
   30 a= an
      b = bn
      c = cn
      be = ben
      if(be.eq.0.) be = 90.
 
      ifmat = 2
      if(long.gt.0) write(nout,40) spgr,axes,a,b,c,be
      if(isc.eq.1.and.long.gt.0) write(*,40) spgr,spgr,a,b,c,be
   40 format(' Transformation of axes into standard setting ',a10,' : ',
     1 a/' New axes :',3f8.4,5x,'beta=',f6.2)
      return
   50 write(nout,51)
      write(*,51)
   51 format(' Division by 0; no transformation performed.')
      return 1
      end
